<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;
use Carbon\Carbon;
use App\Models\Ticket;
use App\Models\Filial;
use App\Models\User;
use App\Models\Invoice\GlobalInvoiceXml;
use App\Models\SoapCalls;
use Storage;
use Mail;
use App\Mail\SendInvoice;
use App\Models\Customer;
use Illuminate\Database\QueryException;
use DB;
use App\Mail\SendGlobalResult;
use Illuminate\Support\Facades\Auth;

class GlobalInvoice extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'globalInvoice';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = '';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */


    public function handle()
    {

        /* $results = [];
        $filials = Filial::activated()->get();

        foreach ($filials as $filial) {

            $invoiceNumber = $filial->prefix . $filial->number_ticket;


            $tickets = Ticket::select('number_ticket', 'amount')
                ->join('user', 'user.id', '=', 'ticket.user_id')
                ->where('filial_id', '=', $filial->id)
                ->whereRaw('ticket.date_limit<=CURDATE()')
                ->where('ticket.status', '=', 'sell')
                ->get();





            foreach ($tickets as $ticket) {
                $ticket->price = round($ticket->amount / 1.16, 4);
                $ticket->iva = round($ticket->price * 0.16, 4);
                $ticket->amount = round($ticket->amount, 4);
            }

            if (!$tickets->isEmpty()) {

                $xml = GlobalInvoiceXml::createXml($filial, $tickets);
                if ($xml["is_file"]) {

                    $response = SoapCalls::getInvoice($xml["path"]);

                    if (!empty($response["xml"])) {

                        Storage::delete('filials/' . $filial->id . '/tickets/' . $filial->prefix . $filial->number_ticket . '.xml');
                        Storage::put('filials/' . $filial->id . '/facturas/' . $filial->prefix . $filial->number_ticket . '.xml', base64_decode($response["xml"]));
                        Storage::put('filials/' . $filial->id . '/facturas/' . $filial->prefix . $filial->number_ticket . '.pdf', base64_decode($response["pdf"]));


                        //Invoice PAths


                        try {

                            DB::beginTransaction();

                            //Update tickets to invoiced on global
                            Ticket::whereIn('number_ticket', $tickets->pluck('number_ticket')->toArray())->update(['status' => 'global_sell']);


                            //Delete stored xml
                            foreach ($tickets as $ticket) {
                                Storage::delete('filials/' . $filial->id . '/tickets/' . $ticket->number_ticket . '_fisica.xml');
                                Storage::delete('filials/' . $filial->id . '/tickets/' . $ticket->number_ticket . '_moral.xml');
                            }


                            //Save global invoice
                            $customer = Customer::where('rfc', '=', 'XAXX010101000')->first();
                            $user = User::where('filial_id', '=', $filial->id)->first();


                            $invoice = Ticket::create([
                                'user_id' => $user->id,
                                'customer_id' => $customer->id,
                                'number_ticket' => $invoiceNumber,
                                'date' => Carbon::now()->toDateTimeString(),
                                'date_limit'=>null,
                                'amount' => array_sum($tickets->pluck('amount')->toArray()),
                                'status' => 'invoice_sell'
                            ]);


                            //Update filial number_ticket
                            $filial->number_ticket = $filial->number_ticket + 1;
                            $filial->save();

                            DB::commit();


                            //Send Invoice
                            Mail::to('cobranza@piezasindustriales.com')
                                ->send(new SendInvoice(
                                    storage_path() . '/app/filials/' . $filial->id . '/facturas/' . $invoiceNumber . '.xml',
                                    storage_path() . '/app/filials/' . $filial->id . '/facturas/' . $invoiceNumber . '.pdf',
                                    $invoice,
                                    ['ataqsa@gmail.com', 'soporte@piezasindustriales.com','depweb@ideasysolucionestecnologicas.com']
                                ));


                            $results[] = [
                                "status" => 1,
                                "filial" => $filial->name,
                                "message" => $response["message"]
                            ];


                        } catch (QueryException $e) {
                            DB::rollBack();

                            $results[] = [
                                "status" => 0,
                                "filial" => $filial->name,
                                "message" => $response["message"] . ', hubo un error al guardar la factura en base de datos ' . $e->getMessage()
                            ];

                        } catch (\Swift_TransportException $e) {

                            $results[] = [
                                "status" => 0,
                                "filial" => $filial->name,
                                "message" => $response["message"] . ', hubo un error al enviar por correo ' . $e->getMessage()
                            ];

                        }
                    } else {
                        $results[] = [
                            "status" => 0,
                            "filial" => $filial->name,
                            "message" => 'Hubo un error al generar la factura' . $response["message"]
                        ];
                    }

                } else {

                    $results[] = [
                        "status" => 0,
                        "filial" => $filial->name,
                        "message" => "No se logró crear el XML para timbrar"
                    ];
                }
            }
        }


        //Send Invoicing results
        Mail::to('cobranza@piezasindustriales.com')
            ->send(new SendGlobalResult($results, ['ataqsa@gmail.com', 'soporte@piezasindustriales.com','depweb@ideasysolucionestecnologicas.com']));
 */

    }
}
