<?php
/**
 * Created by PhpStorm.
 * User: Soporte
 * Date: 03/12/2018
 * Time: 11:14 AM
 */

namespace App\DataTables;

use App\Models\Cancelacion;
use Yajra\Datatables\Services\DataTable;

class CancelacionesDataTable extends DataTable
{
    /**
     * @return \Illuminate\Http\JsonResponse
     */
    public function ajax()
    {
        return $this->datatables
            ->eloquent($this->query())
            ->make(true);
    }

    /**
     * Get the query object to be processed by datatables.
     *
     * @return \Illuminate\Database\Query\Builder|\Illuminate\Database\Eloquent\Builder
     */
    public function query()
    {
        $cancelaciones = Cancelacion::query()->with('users');
        return $this->applyScopes($cancelaciones);
    }

    /**
     * Optional method if you want to use html builder.
     *
     * @return \Yajra\Datatables\Html\Builder
     */
    public function html()
    {
        return $this->builder()
            ->columns($this->getColumns())
            ->ajax('')
            ->parameters([
                'language' => [
                    'url' => '//cdn.datatables.net/plug-ins/1.10.11/i18n/Spanish.json'
                ],
                "lengthMenu" => [[10, 25, 50, 100, -1], [10, 25, 50, 100, "Todos"]],
                "pagingType" => "full_numbers",
                'dom' => 'lBfrtip',
                'scrollX' => false,
                'buttons' => [
                    'reload',
                    [
                        'extend' => 'collection',
                        'text' => '<i class="fa fa-download"></i> Exportar',
                        'buttons' => [
                            'excel',
                            'pdf',
                        ],
                    ]
                ]
            ]);
    }

    /**
     * Get columns.
     *
     * @return array
     */
    private function getColumns()
    {
        return [
            'uuid' => ['name' => 'uuid', 'data' => 'uuid'],
            'Acción' => ['name' => 'accion', 'data' => 'accion'],
            'Usuario' => ['name' => 'users.name', 'data' => 'name'],
            'Fecha Evento' => ['name' => 'created_at', 'data' => 'created_at']
        ];
    }

    /**
     * Get filename for export.
     *
     * @return string
     */
    protected function filename()
    {
        return 'cancelaciones';
    }
}