<?php

namespace App\DataTables;

use App\Models\Filial;
use App\Models\Ticket;
use Carbon\Carbon;
use Faker\Provider\lt_LT\Person;
use Form;
use Yajra\Datatables\Services\DataTable;
use DB;
use Illuminate\Support\Facades\Auth;
use URL;

class TicketDataTable extends DataTable
{


    /* protected function buildExcelFile()
     {

         $excel = app('excel');
         $extraColumns = count($this->getDataForExport()['0']) - 6; // $this->getDataForExport() is where the data is at!
         return \Maatwebsite\Excel\Facades\Excel::create('Ventas', function ($excel) use ($data,$from,$to,$withMoney) {
             $excel->sheet('Excel sheet', function ($sheet) use ($data,$from, $to,$withMoney) {

             });
         });
     }*/


    private function actionButtons($ticket)
    {

        $url = URL::to('/');
        $type_role = Auth::user()->role()->first()->name;
        $html = <<<HTML
<div class="dropdown">
  <button class="btn btn-sm btn-primary dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
    <i class="fa fa-bars"></i>
  </button>
  <ul class="dropdown-menu dropdown-menu-right" aria-labelledby="dropdownMenu1">
    <li>
        <a href="#"  data-ticket="{$ticket->id}" data-number_ticket="{$ticket->number_ticket}" data-note="{$ticket->note}" id="editNote" >
            <i class="fa fa-pencil text-primary"></i> <strong>Editar Observaciones</strong>
        </a>
    </li>
HTML;

        //Date bond for global invoice
        if ($ticket->status == 'invoice_sell') {
            $html .= <<<HTML
    <li>
        <a href="#"  data-ticket="{$ticket->id}" data-number_ticket="{$ticket->number_ticket}"  id="globalDateBond" >
            <i class="fa fa-calendar text-warning"></i> <strong>Marcar fechas de depósito</strong>
        </a>
    </li>
HTML;
        }

        //Send ticket by email button
        if ($ticket->status == 'sell') {

            $urlfixZml = route("ticket.ticketXMLRemake", $ticket->id);
            $html .= <<<HTML
            <li>
                <a href="#"  data-ticket="{$ticket->id}" id="sendTicket" >
                    <i class="fa fa-send text-primary"></i> <strong>Enviar Ticket</strong>
                </a>
            </li>
            <li>
                <a href="#" data-id="{$ticket->id}" data-number_ticket="{$ticket->number_ticket}" id="showTicket" >
                    <i class="fa fa-print text-primary"></i> <strong>Ver Ticket</strong>
                </a>
            </li>
            <li>
                <a href="#" data-route="{$urlfixZml}" data-id="{$ticket->id}" data-number_ticket="{$ticket->number_ticket}" id="fixTicket" >
                    <i class="fa fa-file-excel-o text-primary"></i> <strong>Reparar XML</strong>
                </a>
            </li>
HTML;
        }


        //Cancel ticket button only available to superadmin user
        if (Auth::user()->role->permissions->request_cancel_ticket && $ticket->status == 'sell') {
            $html .= <<<HTML
           <li> <a href="#"  data-invoice="{$ticket->id}" id="rcancelTicket">
                <i class="fa fa-times-circle text-danger"></i> <strong>Cancelar Ticket</strong>
                </a>
           </li>
HTML;
        }else if(($ticket->status == 'request_cancelled' || $ticket->status == 'sell') && Auth:: user()->role->permissions->cancel_ticket) {
            $html .= <<<HTML
           <li> <a href="#"  data-invoice="{$ticket->id}" id="cancelTicket" data-type="{$type_role} ">
                <i class="fa fa-times-circle text-danger"></i> <strong>Cancelar Ticket</strong>
                </a>
           </li>
HTML;
        }

        //Cancel invoice, PDF and XML downloadable invoice files 
        if (($ticket->status == 'invoiced' || $ticket->status == 'invoice_sell') && Auth::user()->role->permissions->cancel_invoice) {
            $html .= <<<HTML
            <li><a href="#"  id="cancelInvoice" data-invoice="{$ticket->id}">
                    <i class="fa fa-file-pdf-o text-danger"></i> <strong>Cancelar Factura</strong>
                </a>
            </li>
HTML;
        }

        if($ticket->userShift->user->filial["related_filial"] !== null){
            $filial = Filial::find($ticket->userShift->user->filial["related_filial"]);
        }else{
            $filial = $ticket->userShift->user->filial;
        }
        if ($ticket->status == 'invoiced' || $ticket->status == 'invoice_sell' || $ticket->status == 'invoice_cancelled') {
            $html .= <<<HTML
            <li>
                <a href="#" id="sendInvoice" data-customer="{$ticket->customer_id}" data-invoice="{$ticket->id}">
                    <i class="fa fa-send text-primary"></i> <strong>Enviar Factura</strong>
                </a>
            </li>
            <li>
                <a href="{$url}/../storage/app/filials/{$filial->id}/facturas/{$ticket->invoice}.xml"
                    download="{$ticket->invoice}.xml"
                    >
                    <i class="fa fa-file-text-o text-success"></i> <strong>XML</strong>
                </a>
            </li>
            <li>
                <a href="{$url}/../storage/app/filials/{$filial->id}/facturas/{$ticket->invoice}.pdf"
                download="{$ticket->invoice}.pdf"
                >
                    <i class="fa fa-file-pdf-o text-danger"></i> <strong>PDF</strong>
                </a>
            </li>

HTML;

        }


        //PDF and XML invoiced cancelled files
        if ($ticket->status == 'invoice_cancelled') {

            $urlreInvoice = route("ticket.reInvoice", $ticket->id);
            $getTicketInfo = route("ticket.reInvoice", $ticket->id);
            $html .= <<<HTML
                <li>
                    <a href="{$url}/../storage/app/filials/{$ticket->userShiftuserfilial_id}/facturas/{$ticket->invoice}_acuse.xml"
                        download="{$ticket->number_ticket}_acuse.xml">
                        <i class="fa fa-file-text-o text-success"></i> <strong>Acuse XML</strong>
                    </a>
                </li>
                <li>
                    <a href="{$url}/../storage/app/filials/{$ticket->userShift->user->filial_id}/facturas/{$ticket->invoice}_acuse.pdf"
                    download="{$ticket->number_ticket}_acuse.pdf"
                    >
                        <i class="fa fa-file-pdf-o text-danger"></i> <strong>Acuse PDF</strong>
                    </a>
                </li>
                <li>
                    <a href="{$url}/../storage/app/filials/{$ticket->userShift->user->filial_id}/facturas/{$ticket->number_ticket}_acuse.pdf"
                    download="{$ticket->number_ticket}_acuse.pdf"
                    >
                        <i class="fa fa-check-circle-o text-gray"></i> <strong>Revisar Estado de Cancelación</strong>
                    </a>
                </li>
                <li>
                <a href="#" data-get="" data-route="{$urlreInvoice}" data-id="{$ticket->id}" data-number_ticket="{$ticket->number_ticket}" id="reInvoiceTicket" >
                    <i class="fa fa-file-excel-o text-primary"></i> <strong>Refacturar con Nuevo Folio</strong>
                </a>
            </li>
HTML;
        }


        $html .= '</ul></div>';

        return $html;

    }

    /**
     * @return \Illuminate\Http\JsonResponse
     */
    public function ajax()
    {
        return $this->datatables
            ->eloquent($this->query())
            ->rawColumns(['action', 'id', 'status', 'pay', 'metodo_pago'])
            ->addColumn('action', 'tickets.datatables_actions')
            ->addColumn('action', function ($ticket) {
                return $this->actionButtons($ticket);
            })
            ->editColumn('ticket_items.car.owner.name', function ($ticket) {
              if (isset($ticket->ticketItems))
                  return $ticket->ticketItems->car->owner->name;
              else
                  return null;
            })
            ->editColumn('pay', function ($ticket) {
                $checked = "";
                $disabled = "";
                $route = route("ticketPays.storeTicketPay", $ticket["id"]);
                if (($ticket->pay)) {
                    $checked = "checked";
                }
                if (($ticket->pay) || $ticket->status == 'cancelled' || $ticket->status == 'request_cancelled') {
                    $disabled = "disabled";
                }
                return <<<HTML
                    <label class="container">
                        <input type="checkbox" name="checkPay" id="checkPay" $disabled $checked data-route="$route" data-number_ticket="{$ticket->number_ticket}" data-ticket="{$ticket->id}">
                        <span class="checkmark"></span>
                    </label>
HTML;
            })
            ->editColumn('id', function ($data) {
                if (Auth::user()->role_id == "1") {
                    $checked = "";
                    $disabled = "";
                    $route = route("tickets.invalidTicket", $data["id"]);
                    if (($data->status) == "system_no_valid") {
                        $checked = "checked";
                    }
                    if ($data->status != 'sell' && $data->status != 'system_no_valid') {
                        $disabled = "disabled";
                    }
                    return <<<HTML
                    <label class="container2">
                        <input type="checkbox" name="checkNoValid"
                        data-route="$route"
                        $disabled $checked
                        data-number_ticket="{$data->number_ticket}" 
                        data-invoice="{$data->id}">
                        <span class="checkmark2"></span>
                    </label>
HTML;
                }
            })
            ->editColumn('number_ticket', function ($data) {

                $path = storage_path() . '/app/filials/' . $data->userShift->user->filial_id . '/facturas/' . $data->number_ticket . '.xml';
                if (is_file($path) || $data->status == 'invoiced' || $data->status == 'invoice_sell' || $data->status == 'invoice_cancelled')
                    return $data->number_ticket;

                return $data->number_ticket;
            })
            ->editColumn('date', function ($data) {
                return $data->date->format('Y-m-d');
            })
            ->editColumn('customer_id', function ($data) {
                if (!empty($data->customer))
                    return $data->customer->name;

                return 'Mostrador';
            })
            ->editColumn('subtotal', function ($data) {
                $new_amount = 0;
                if (isset($data->total_efectivo_count)) {
                    foreach ($data->ticketMethodPayment as $mp) {
                        if ($mp->methodPayment->type == "efectivo") {
                            $new_amount += $mp->amount;
                        }
                    }
                    return number_format($new_amount, 2);
                } else {
                    return number_format($data->subtotal, 2);
                }
            })
            ->editColumn('iva', function ($data) {
                return number_format($data->iva, 2);
            })
            ->editColumn('metodo_pago', function ($data) {
                $html_metodo = "";

                if(isset($data->ticketMethodPayment)) {
                    foreach ($data->ticketMethodPayment as $mp) {
                        if (isset($data->total_efectivo_count)) {
                            if ($mp->methodPayment->type == "efectivo") {
                                if ($mp->exchangeRate->coin->key == "MXN") {
                                    $html_metodo .= '<h5><span class="badge badge-success">' . $mp->methodPayment->type . ": $" . $mp->amount . " " . $mp->methodPayment->coin->key . "</span></h5>";
                                } else {
                                    $html_metodo .= '<h5><span class="badge badge-warning">' . $mp->methodPayment->type . ": $" . $mp->amount . " " . $mp->methodPayment->coin->key . "</span></h5>";
                                    $html_metodo .= '<h5><span class="badge badge-success">' . "cambio: $" . ($mp->amount * $mp->exchangeRate->exchange_rate) . " MXN" . "</span></h5>";
                                }
                            }
                        } else {
                            if ($mp->methodPayment->type == "efectivo") {
                                if ($mp->exchangeRate->coin->key == "MXN") {
                                    $html_metodo .= '<h5><span class="badge badge-success">' . $mp->methodPayment->type . ": $" . $mp->amount . " " . $mp->methodPayment->coin->key . "</span></h5>";
                                } else {
                                    $html_metodo .= '<h5><span class="badge badge-warning">' . $mp->methodPayment->type . ": $" . $mp->amount . " " . $mp->methodPayment->coin->key . "</span></h5>";
                                    $html_metodo .= '<h5><span class="badge badge-success">' . "cambio: $" . ($mp->amount * $mp->exchangeRate->exchange_rate) . " MXN" . "</span></h5>";
                                }
                            } else {
                                $html_metodo .= '<h5><span class="badge badge-inverse">' . $mp->methodPayment->type . ": $" . $mp->amount . " " . $mp->methodPayment->coin->key . "</span></h5>";
                            }
                        }
                    }
                }
                return $html_metodo;
            })
            ->editColumn('ret_iva', function ($data) {
                return number_format($data->ret_iva, 2);
            })
            ->editColumn('amount', function ($data) {
                $new_amount = 0;
                if (isset($data->total_efectivo_count)) {
                    foreach ($data->ticketMethodPayment as $mp) {
                        if ($mp->methodPayment->type == "efectivo") {
                            $new_amount += $mp->amount;
                        }
                    }
                    return number_format($new_amount, 2);
                } else {
                    return number_format($data->amount, 2);
                }


            })
            ->editColumn('status', function ($data) {


                $personType = $data->customer->type;
                switch ($data->status) {
                    case 'sell':
                        return '<span class="badge badge-warning">Ticket</span>';
                        break;
                    case 'global_sell':
                        return '<span class="badge badge-warning">Ticket en global</span>';
                        break;
                    case 'invoice_sell':
                        return '<span class="badge badge-warning">Factura global</span>';
                        break;
                    case 'invoiced':
                        return '<span class="badge badge-success">Factura ' . $personType . '</span>';
                        break;
                    case 'invoice_cancelled':
                        return '<span class="badge badge-danger">Factura cancelada ' . $personType . '</span>';
                        break;
                    case 'cancelled':
                        return '<span class="badge badge-danger">Ticket cancelado</span>';
                        break;
                    case 'request_cancelled':
                        return '<span class="badge badge-danger">En espera de cancelación</span>';
                        break;
                    case 'system_no_valid':
                        return '<span class="badge badge-danger">Ticket No válido</span>';
                        break;
                }

            })
            ->make(true);
    }

    /**
     * Get the query object to be processed by datatables.
     *
     * @return \Illuminate\Database\Query\Builder|\Illuminate\Database\Eloquent\Builder
     */
    public function query()
    {
        $from = $this->request()->get('from');
        $to = $this->request()->get('to');
        $status = $this->request()->get('status');
        $customer = $this->request()->get('customer');
        $filial = $this->request()->get('filial');
        $user = $this->request()->get('user');
        $owner = $this->request()->get('owner');
        $coin = $this->request()->get('coin');
        $methodPayment = $this->request()->get('methodPayment');
        $personType = $this->request()->get('person_type');
        $withPayed = $this->request()->get('withPayed');
        $withInvoice = $this->request()->get('withInvoice');
        $withMoney = $this->request()->get('withMoney');
        $noValid = $this->request()->get('noValid');

        $invoices = Ticket::query()->select(
            "ticket.*",
            DB::raw("IF(pay = 1 OR status = 'cancelled' OR status = 'request_cancelled' ,0,amount) AS saldo"))
            ->with("ticketItems")->with("ticketItems.car")->with("ticketItems.car.owner")
            ->with("ticketMethodPayment")->with("ticketMethodPayment.methodPayment")->with("ticketMethodPayment.methodPayment.coin")
            ->with("ticketMethodPayment.exchangeRate")->with("ticketMethodPayment.exchangeRate.coin")
            ->with("userShift")->with("userShift.user")
            ->with("customer")->with("ticketItems");

        if (!empty($owner)) {
            $invoices->whereHas("ticketItems.car", function ($query) use ($owner) {
                if (!empty($owner)) {
                    $query->where('car.owner_id', '=', $owner);
                }
            });
        }
        if (!empty($personType))
            $invoices->where('customer.type', '=', $personType);
        if (!empty($filial)) {
            $invoices->where('user_shift.user.filial_id', '=', Auth::user()->filial_id);
        }
        if (!empty($customer)) {
            $invoices->where('customer_id', '=', $customer);
        }
        if (!empty($from) && !empty($to)) {
            $invoices->whereBetween(DB::raw('DATE_FORMAT(date,"%Y-%m-%d")'), [$from, $to]);
        }else{
            $date = Carbon::now();
            $periodo = [];
            $day = $date->day;
            if ($day > 11){
                $periodo["init"] = $date->startOfMonth()->format("Y-m-d");
                $periodo["final"] = $date->endOfMonth()->addDays(11)->format("Y-m-d");
            }else{
                $lastMonth = $date->subMonth(1);

                $periodo["init"] = $lastMonth->startOfMonth()->format("Y-m-d");
                $periodo["final"] = $lastMonth->endOfMonth()->addDays(11)->format("Y-m-d");
            }
            $invoices->whereBetween(DB::raw('DATE_FORMAT(date,"%Y-%m-%d")'), [$periodo["init"], $periodo["final"]]);
        }
        if (!empty($status)) {
            $invoices->whereIn('ticket.status', $status);
        }
        if (!empty($withPayed)) {
            if ($withPayed == 1) {
                $invoices->where('ticket.pay', $withPayed);
            }
        }
        if (!empty($withInvoice)) {
            if ($withInvoice == 1) {
                $invoices->where('ticket.status', "=", "invoiced");
            }
        }
        if (!empty($noValid)) {
            if ($noValid == 1) {
                $invoices->where('ticket.status', "=", "system_no_valid");
            }
        } else {
            $invoices->where('ticket.status', "!=", "system_no_valid");
        }
        if (!empty($withMoney)) {
            $invoices
                ->withCount(["ticketMethodPayment AS total_efectivo" => function ($q) use ($withMoney) {
                    if ($withMoney == 1) {
                        $q->where("method_payment_id", "=", 2);
                    }
                }])
                ->whereHas("ticketMethodPayment.methodPayment", function ($query) use ($withMoney) {
                    if ($withMoney == 1) {
                        $query->where("type", "=", "efectivo");
                    }
                });
        }


        return $this->applyScopes($invoices);
    }

    /**
     * Optional method if you want to use html builder.
     *
     * @return \Yajra\Datatables\Html\Builder
     */
    public function html()
    {
        return $this->builder()
            ->columns($this->getColumns())
            ->addAction(['width' => '5%'])
            ->ajax('')
            ->parameters([
                'language' => [
                    'url' => url('vendor\datatables\lang\es.json')
                ],
                'order' => [2, 'asc'],
                "lengthMenu" => [[10, 25, 50, 100, -1], [10, 25, 50, 100, "Todos"]],
                'dom' => 'lBfrtip',
                'scrollX' => true,
                'buttons' => [
                    ["extend" => "reload", "text" => "<i class='fa fa-refresh'></i> Recargar"],
                    ["extend" => "print", "text" => "<i class='fa fa-print'></i> Imprimir"],
                    [
                        'extend' => 'collection',
                        'text' => '<i class="fa fa-download"></i> Exportar',
                        'buttons' => [
                            'csv',
                            'excel',
                            'pdf',
                        ],
                    ],
                    ["extend" => "colvis", "text" => "<i class='fa fa-list-alt'></i> Seleccionar columnas"],
                ]
            ]);
    }

    /**
     * Get columns.
     *
     * @return array
     */
    private function getColumns()
    {

        if (Auth::user()->role->permissions->first()->general_report) {
            return [
                'id' => ['name' => 'id', 'data' => 'id', 'searchable' => false, 'orderable' => false, 'width' => '1%'],
                'folio' => ['name' => 'number_ticket', 'data' => 'number_ticket'],
                'Factura' => ['name' => 'invoice', 'data' => 'invoice'],
                // 'OT' => ['name' => 'job_order', 'data' => 'job_order'],
                'cliente' => ['name' => 'customer_id', 'data' => 'customer_id', 'searchable' => false],
                'metodo_pago' => ['name' => 'ticket_method_payment.method_payment.type', 'data' => 'metodo_pago','searchable' => false,'orderable' => false],
                'Dueño' => ['name' => "ticket_items.car.owner.name", 'data' => "ticket_items.car.owner.name", 'searchable' => false,'orderable' => false],
                'fecha' => ['name' => 'date', 'data' => 'date'],
                // 'fecha_deposito' => ['name' => 'date_bond', 'data' => 'date_bond'],
                'subtotal' => ['name' => 'subtotal', 'data' => 'subtotal', "class" => "hidden"],
                'iva' => ['name' => 'iva', 'data' => 'iva', "class" => "hidden"],
                // 'ret_iva' => ['name' => 'ret_iva', 'data' => 'ret_iva'],
                'importe' => ['name' => 'amount', 'data' => 'amount'],
                'notas' => ['name' => 'note', 'data' => 'note', "class" => "hidden"],
                'Saldo' => ['name' => 'saldo', 'data' => 'saldo','searchable' => false,'orderable' => false],
                'pagado_a_dueño' => ['name' => 'pay', 'data' => 'pay'],
                'status' => ['name' => 'status', 'data' => 'status', 'width']
            ];
        }
        else{
            return [
                //'id' => ['name' => 'id', 'data' => 'id', 'searchable' => false, 'orderable' => false, 'width' => '1%'],
                'folio' => ['name' => 'number_ticket', 'data' => 'number_ticket'],
                'Factura' => ['name' => 'invoice', 'data' => 'invoice'],
                // 'OT' => ['name' => 'job_order', 'data' => 'job_order'],
                'cliente' => ['name' => 'customer_id', 'data' => 'customer_id', 'searchable' => false],
                'metodo_pago' => ['name' => 'ticket_method_payment.method_payment.type', 'data' => 'metodo_pago','searchable' => false,'orderable' => false],
                'Dueño' => ['name' => "ticket_items.car.owner.name", 'data' => "ticket_items.car.owner.name", 'searchable' => false,'orderable' => false],
                'fecha' => ['name' => 'date', 'data' => 'date'],
                // 'fecha_deposito' => ['name' => 'date_bond', 'data' => 'date_bond'],
                'subtotal' => ['name' => 'subtotal', 'data' => 'subtotal', "class" => "hidden"],
                'iva' => ['name' => 'iva', 'data' => 'iva', "class" => "hidden"],
                // 'ret_iva' => ['name' => 'ret_iva', 'data' => 'ret_iva'],
                'importe' => ['name' => 'amount', 'data' => 'amount'],
                'notas' => ['name' => 'note', 'data' => 'note', "class" => "hidden"],
                'Saldo' => ['name' => 'saldo', 'data' => 'saldo','searchable' => false,'orderable' => false],
                'pagado_a_dueño' => ['name' => 'pay', 'data' => 'pay'],
                'status' => ['name' => 'status', 'data' => 'status', 'width']
            ];
        }
    }

    /**
     * Get filename for export.
     *
     * @return string
     */
    protected function filename()
    {
        return 'facturas';
    }
}
