<?php

namespace App\Http\Controllers\Auth;

use App\Http\Controllers\Controller;
use Illuminate\Foundation\Auth\AuthenticatesUsers;
use Illuminate\Http\Request;
use Auth;

class LoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
     */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = '/home';
    protected $redirectWelcome = '/welcome';


    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest')->except('logout');
    }

    public function username()
    {
        return 'username';
    }

    
    public function login(Request $request)
    {

        $this->validateLogin($request);
        $username = $request->input('username');
        $password = $request->input('password');
        $remember = $request->input('remember');



        if (Auth::attempt(['username' => $username, 'password' => $password, 'status' => 1], $remember)) {
            return redirect()->intended($this->redirectTo);
        } else {

            return $this->sendFailedLoginResponse($request);
        }


    }

    public function logout(Request $request)
    {
        \Auth::logout();
        session()->flush();
        return redirect(route('login'));

    }

}
