<?php
/**
 * Created by PhpStorm.
 * User: Soporte
 * Date: 28/11/2018
 * Time: 05:25 PM
 */

namespace App\Http\Controllers;

use App\DataTables\CancelacionesDataTable;
/*use App\Models\Cancelacion;
use App\Models\Factura;
use App\Models\FacturaReferencia;*/
use App\Models\Invoice\Cancelacion as LibCancelacion;
use Carbon\Carbon;
use DB;
use FPDI;
use Illuminate\Database\QueryException;

class CancelacionController extends AppBaseController
{

    public function __construct()
    {

    }

    /**
     * Consulta de mi propio Buzón Tributario
     *
     * @return $this
     */
    public function index()
    {
        $cancelacion = new LibCancelacion();
        $response = $cancelacion->ConsultarMisFacturas();
        $mensaje_original = $response['mensaje_original'];
        $message = json_decode($mensaje_original, true);
//        dd($message);
        return view('cancelacion.index')->with(['response' => $message]);
    }

    /**
     * Definir el estatus de las peticiones de cancelaciones para mi RFC
     *
     * @param string $action
     * @param string $uuid
     * @return \Illuminate\Http\JsonResponse
     */
    public function setCancelation($action, $uuid)
    {
        $cancelacion = new LibCancelacion();
        $response = $cancelacion->updateCancelation($action, $uuid);
        $mensaje_original = $response['mensaje_original'];
        $message = json_decode($mensaje_original, true);
        if ($response['status'] == 'error')
            return response()->json(['msg' => $message['messageDetail']], 400);
        else {
            Cancelacion::create([
                'uuid' => $uuid,
                'accion' => $action == 'aceptar' ? 'Cancelación Aceptada' : 'Cancelación Rechazada',
                'users_id' => \Auth::user()->id
            ]);
            return response()->json(['msg' => $message['messageDetail']], 200);
        }
    }

    /**
     * @param CancelacionesDataTable $cancelacionesDataTable
     * @return \Illuminate\Contracts\View\View|\Illuminate\Http\JsonResponse|\Illuminate\View\View
     */
    public function historial(CancelacionesDataTable $cancelacionesDataTable)
    {
        return $cancelacionesDataTable->render('cancelacion.historial');
    }

    /**
     * Consulta el estatus de la factura para determinar si se actualiza el estado de la factura
     *
     * @param string $folio
     * @return \Illuminate\Http\JsonResponse
     * @throws \Exception
     */
    /*public function facturaStatus($folio)
    {
        $factura = Factura::with('facturasReferenciaDestino.facturaOrigen')->with('facturasReferenciaDestino.facturaReferenciada')->find($folio);
        $xml_url = url('/../storage/app/facturas/' . session('empresaID') . '/' . $folio . '.xml');
        $pdf_url = url('/../storage/app/facturas/' . session('empresaID') . '/' . $folio . '.pdf');
        if (file_exists($xml_url)) {
            $consulta = new LibCancelacion();
            $response = $consulta->consultaEstatus($xml_url);
            $response = $response['consulta'];
            if (isset($response['EstatusCancelacion'])) {
                if (is_string($response['EstatusCancelacion'])) {
                    try {
                        DB::beginTransaction();
                        $factura->status_cancelacion = $response['EstatusCancelacion'];
                        if ($response['Estado'] == 'Cancelado') {
                            $factura->status = 'cancelada';
                            //En caso de notas de credito y recepcion de pago reestablecer el saldo
                            foreach ($factura->facturasReferenciaDestino as $referencia) {
                                if ($referencia->id_tipo_cfdi == 1 || $referencia->id_tipo_cfdi == 7) {
                                    //REestablecer saldo
                                    $oldSaldo = $referencia->facturaOrigen->saldo;
                                    $referencia->facturaOrigen->saldo = $referencia->facturaOrigen->saldo + $referencia->facturaReferenciada->total;
                                    $referencia->facturaOrigen->save();
                                    //Insertar movimiento a los saldos
                                    FacturaReferencia::create([
                                        'id_factura_referenciada' => $referencia->id_factura_referenciada,
                                        'id_factura_origen' => $referencia->facturaOrigen->id_factura,
                                        'id_relacion_cfdi' => $referencia->id_relacion_cfdi,
                                        'fecha' => Carbon::now()->toDateString(),
                                        'tipo_cambio' => $referencia->tipo_cambio,
                                        'saldo_ant' => $oldSaldo,
                                        'nuevo_saldo' => $referencia->facturaOrigen->saldo,
                                        'parcialidad' => null,
                                        'status' => 'cancelado'
                                    ]);
                                }
                            }
                            $pdf = new FPDI('P', 'mm', array(279.4, 216), false, 'UTF-8', false);
                            $pdf->SetMargins(PDF_MARGIN_LEFT, 40, PDF_MARGIN_RIGHT);
                            $pdf->SetAutoPageBreak(true, 40);
                            $pdf->setFontSubsetting(false);
                            $pagecount = $pdf->setSourceFile($pdf_url);
                            for ($i = 1; $i <= $pagecount; $i++) {
                                $pdf->AddPage();
                                $pdf->Line(0, 12, 350, 12, array('width' => 1, 'cap' => 'butt', 'join' => 'miter', 'dash' => 0, 'color' => array(255, 255, 255)));
                                $pdf->setSourceFile($pdf_url);
                                $tplIdx = $pdf->importPage($i);
                                $pdf->useTemplate($tplIdx, 0, 0, 0);
                                $pdf->SetTextColor(255, 0, 0);
                                $pdf->SetFont('helvetica', 'B', 80);
                                $pdf->StartTransform();
                                $pdf->SetAlpha(0.5);
                                $pdf->SetAutoPageBreak(false, 0);
                                $pdf->writeHTML('CANCELADA', true, false, false, false, 'T');
                                $pdf->setPageMark();
                                $pdf->StopTransform();
                                $pdf->setFont('helvetica', 'B', 20);
                                $pdf->SetAlpha(0.5);
                                $pdf->writeHTML('Fecha de Cancelacion: ' . $factura->fecha_cancelacion);
                            }
                            $pdf->Output($pdf_url, 'F');
                        }
                        $factura->save();
                        DB::commit();
                    } catch (QueryException $e) {
                        DB::rollBack();
                        return response()->json(['msg' => $e->getMessage()], 400);
                    }
                }
            } else
                return response()->json(['msg' => 'Hubo un error al intentar consultar el estatus de la factura'], 400);
            return response()->json($response['consulta'], 200);
        } else
            return response()->json(['msg' => 'No fue posible encontrar el archivo XML de la factura'], 400);
        /**
         * [
         *  [CodigoEstatus] => S - Comprobante obtenido satisfactoriamente.
         *  [EsCancelable] => Cancelable con aceptación
         *  [Estado] => Cancelado
         *  [EstatusCancelacion] => Cancelado con aceptación
         *  [produccion] => SI
         * ]

    }*/

}