<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\TicketGlobalItem;
use Illuminate\Database\QueryException;
use DB;

class TicketGlobalItemController extends Controller
{
    public function getItems($ticket_id)
    {
        $items = TicketGlobalItem::where('ticket_global_id', $ticket_id)
            ->with('relatedTicket')
            ->get();

        return response()->json(["items" => $items], 200);
    }

    public function updateBondDates(Request $request)
    {


        try {
            DB::beginTransaction();

            $noTickets = count($request["ticket"]["id"]);
            for ($i = 0; $i < $noTickets; ++$i) {
                TicketGlobalItem::where('id', $request["ticket"]["id"][$i])
                    ->update(['date_bond' => $request["ticket"]["date_bond"][$i]]);
            }

            DB::commit();

            return response()->json(["msg" => "Fechas de depósito actualizadas correctamente"], 200);
        } catch (QueryException $e) {

            DB::rollBack();
            return response()->json(["msg" => "Error al actualizar las fechas de depósito intente más tarde"], 500);

        }
    }
}
