<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class ChangePasswordRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        return [
            'email' => 'email|required|unique:user,email,' . \Request::segment(3) . ',id',
            'username' => 'required|unique:user,username,' . \Request::segment(3) . ',id',
            'password' => 'required|min:6',
        ];
    }

    public function messages()
    {

        return [
          'email.required'=>'El correo del usuario es obligatorio',
          'email.unique'=>'Este correo ya ha sido registrado',
          'username.required'=>'El nombre de usuario es obligatorio',
          'username.unique'=>'Este nombre de usuario ya ha sido registrado',
          'password.required'=>'La contraseña del usuario es obligatoria',
          'password.min'=>'La contraseña del usuario debe contener al menos 6 caracteres',
        ];
    }
}
