<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class SendGlobalResult extends Mailable
{
    use Queueable, SerializesModels;

    public $results;
    public $copies;
    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct($results, $copies)
    {
        $this->results = $results;
        $this->copies = $copies;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this
            ->subject('Envio de Resultados de Facturas Globales')
            ->from('contacto@taxisaeropuertoqro.com')
            ->bcc($this->copies)
            ->view('emails.globalInvoiceResults');
    }
}
