<?php

namespace App\Mail;

use Illuminate\Bus\Queueable;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Contracts\Queue\ShouldQueue;

class SendInvoice extends Mailable
{
    use Queueable, SerializesModels;

    /**
     * Create a new message instance.
     *
     * @return void
     */

    public $xml;
    public $pdf;
    public $invoice;
    public $copies;

    public function __construct($xml, $pdf, $invoice, $copies = [])
    {
        $this->xml = $xml;
        $this->pdf = $pdf;
        $this->invoice = $invoice;
        $this->copies = $copies;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this
            ->subject('Envio de Factura #' . $this->invoice->number_ticket . ' PERMISIONARIOS DE QUERÉTARO A.C.')
            ->from('contacto@taxisaeropuertoqro.com')
            ->cc(['taxiaeropuertoqro@gmail.com'])
            ->bcc($this->copies)
            ->attach($this->xml)
            ->attach($this->pdf)
            ->view('emails.sendInvoice');
    }
}
