<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * Class APIToken
 * @package App\Models
 * @version January 29, 2018, 5:52 pm UTC
 *
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property string access_token
 * @property string refresh_token
 * @property string|\Carbon\Carbon expires
 */
class APIToken extends Model
{
    use SoftDeletes;

    public $table = 'api_token';
    
    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';


    protected $dates = ['deleted_at'];


    public $fillable = [
        'access_token',
        'refresh_token',
        'expires'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'access_token' => 'string',
        'refresh_token' => 'string'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    
}
