<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class Car
 * @package App\Models
 * @version July 22, 2018, 4:21 pm CDT
 *
 * @property string name
 * @property string description
 */
class Car extends Model
{

    public $table = 'car';
    
    public $timestamps = false;
    
    protected $primaryKey = 'id';

    public $fillable = [
        'owner_id',
        'name',
        'description'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'owner_id' => 'integer',
        'name' => 'string',
        'description' => 'string'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function owner()
    {
        return $this->belongsTo(\App\Models\Owner::class);
    }
}
