<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class CashOutbound
 * @package App\Models
 * @version August 29, 2018, 1:07 pm CDT
 *
 * @property \App\Models\Car car
 * @property \App\Models\UserShift userShift
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer user_shift_id
 * @property string description
 * @property float amount
 * @property string|\Carbon\Carbon created_at
 * @property integer car_id
 */
class CashOutbound extends Model
{

    const UPDATED_AT = null;
    const CREATED_AT = 'created_at';
    public $table = 'cash_outbound';
    
    public $timestamps = true;



    public $fillable = [
        'user_shift_id',
        'description',
        'amount',
        'return_amount',
        'created_at',
        'car_id',
        'type'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'user_shift_id' => 'integer',
        'description' => 'string',
        'amount' => 'float',
        'return_amount' => 'float',
        'car_id' => 'integer',
        'type' => 'string',
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function car()
    {
        return $this->belongsTo(\App\Models\Car::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function userShift()
    {
        return $this->belongsTo(\App\Models\UserShift::class);
    }
}
