<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class CashRegister
 * @package App\Models
 * @version September 5, 2018, 11:22 am CDT
 *
 * @property \Illuminate\Database\Eloquent\Collection cashOutbound
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketPay
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property \Illuminate\Database\Eloquent\Collection UserShift
 * @property string code
 * @property boolean active
 * @property string|\Carbon\Carbon created_at
 */
class CashRegister extends Model
{

    public $table = 'cash_register';
    
    public $timestamps = false;



    public $fillable = [
        'code',
        'active',
        'created_at'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'code' => 'string',
        'active' => 'boolean'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     **/
    public function userShifts()
    {
        return $this->hasMany(\App\Models\UserShift::class);
    }
}
