<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class Cashback
 * @package App\Models
 * @version October 2, 2018, 10:51 am CDT
 *
 * @property \App\Models\Coin coin
 * @property \App\Models\TicketMethodPayment ticketMethodPayment
 * @property \Illuminate\Database\Eloquent\Collection cashOutbound
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketPay
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property \Illuminate\Database\Eloquent\Collection userShift
 * @property \Illuminate\Database\Eloquent\Collection userShiftCoin
 * @property integer ticket_method_payment_id
 * @property integer coin_id
 * @property float cashback
 * @property string|\Carbon\Carbon created_at
 */
class Cashback extends Model
{

    public $table = 'cashback';
    
    public $timestamps = false;



    public $fillable = [
        'ticket_method_payment_id',
        'coin_id',
        'cashback',
        'created_at'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'ticket_method_payment_id' => 'integer',
        'coin_id' => 'integer',
        'cashback' => 'float'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function coin()
    {
        return $this->belongsTo(\App\Models\Coin::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function ticketMethodPayment()
    {
        return $this->belongsTo(\App\Models\TicketMethodPayment::class);
    }
}
