<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class Coin
 * @package App\Models
 * @version July 23, 2018, 10:07 am CDT
 *
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property string key
 * @property string description
 * @property boolean status
 */
class Coin extends Model
{

    public $table = 'coin';
    
    public $timestamps = false;

    protected $primaryKey = 'id';

    public $fillable = [
        'key',
        'description',
        'status'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'key' => 'string',
        'description' => 'string',
        'status' => 'integer'
    ];

    public function scopeActivated($query) {
        return $query->where('status', '=', 1);
    }
    
    public function scopeDeactivated($query) {
        return $query->where('status', '=', 0);
    }

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    
}
