<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class ExchangeRate
 * @package App\Models
 * @version July 24, 2018, 1:00 pm CDT
 *
 * @property \App\Models\Coin coin
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer coin_id
 * @property float exchange_rate
 * @property date date
 * @property boolean status
 */
class ExchangeRate extends Model
{

    public $table = 'exchange_rate';
    
    public $timestamps = false;


    protected $primaryKey = 'id';

    public $fillable = [
        'coin_id',
        'exchange_rate',
        'date',
        'status'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'coin_id' => 'integer',
        'exchange_rate' => 'float',
        'date' => 'date_format:Y-m-d',
        'status' => 'boolean'
    ];

    public function scopeActivated($query)
    {
        return $query->where('status', '=', 1);
    }

    public function scopeDeactivated($query)
    {
        return $query->where('status', '=', 0);
    }

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function coin()
    {
        return $this->belongsTo(\App\Models\Coin::class);
    }
}
