<?php

/**

 * Created by PhpStorm.

 * User: Soporte

 * Date: 16/03/2018

 * Time: 03:25 PM

 */



namespace App\Models\Export\EXCEL;



use Excel;



class ExportTicket extends Excel

{

    public static function ticketReport($data,$from,$to,$withMoney)
    {
        $excel = Excel::create('Reporte', function ($excel) use ($data,$from,$to,$withMoney) {
            $excel->setTitle('Reporte');
            $excel->setCreator('Reporte de tickets')->setCompany('ISOTECH');
            $excel->sheet('Reporte', function ($reporte) use ($data,$from,$to,$withMoney) {
                $index = 1;
                //dd($data);

                $reporte->row($index,array("Fec_Ini","Fec_Fin"));
                $reporte->row($index, function($row) {
                    // call cell manipulation methods
                    $row->setBackground('#2160BD');
                });
                $index++;
                $reporte->row($index,array($from,$to));
                $index++;

                $reporte->row($index,array("ID","Fecha","Ticket","Descripcion","Método de Pago","Moneda","Dueño","Tipo de cambio","Monto","MontoMX","Total","TotalMX","Pagado","Estatus"));
                $reporte->row($index, function($row) {
                    // call cell manipulation methods
                    $row->setBackground('#2160BD');
                });
                $index++;

                $monto_total = 0;
                $monto_mx_total = 0;
                $total_total = 0;
                $total_mx_total = 0;
                $pagado = 0;

                foreach($data as $o => $ticket) {
                    $methods = "";
                    $monto = 0;
                    $monto_mx = 0;

                    foreach($ticket["ticket_method_payment"] as $t => $methodPayent){
                        if ($t == 0) {
                            $methods .= $methodPayent["method_payment"]["key"];
                        } else {
                            $methods .= ", " . $methodPayent["method_payment"]["key"];
                        }

                        if($withMoney) {
                            if($methodPayent["method_payment"]["type"] == "efectivo"){
                                $monto += floatval($methodPayent["amount"]);
                                $monto_mx += floatval($methodPayent["amount"]) * floatval($ticket["ticket_method_payment"][0]["exchange_rate"]["exchange_rate"]);
                            }
                        }else{
                            $monto += floatval($methodPayent["amount"]);
                            $monto_mx += floatval($methodPayent["amount"]) * floatval($ticket["ticket_method_payment"][0]["exchange_rate"]["exchange_rate"]);
                        }
                    }

                    $reporte->row($index,
                        [
                            $ticket["id"],
                            $ticket["date"],
                            $ticket["number_ticket"],
                            $ticket["ticket_items"]["description"],
                            $methods,
                            $ticket["ticket_method_payment"][0]["method_payment"]["coin"]["key"],
                            $ticket["ticket_items"]["car"]["owner"]["name"],
                            $ticket["ticket_method_payment"][0]["exchange_rate"]["exchange_rate"],
                            $monto,
                            $monto_mx,
                            $ticket["amount"],
                            $ticket["amount_mx"],
                            ($ticket["pay"])?$ticket["amount_mx"]:0,
                            $ticket["status"],

                        ]
                    );
                    $index++;

                    $monto_total += $monto;
                    $monto_mx_total += $monto_mx;
                    $total_total += floatval($ticket["amount"]);
                    $total_mx_total += floatval($ticket["amount_mx"]);
                    $pagado += ($ticket["pay"])?floatval($ticket["amount_mx"]):0;
                    // lots of formatting code here
                }
                $reporte->row($index,array("","","","","","","","","",$monto_mx_total,"",$total_mx_total,$pagado,""));
                $reporte->row($index, function($row) {
                    // call cell manipulation methods
                    $row->setBackground('#2160BD');
                });
                $index++;


            });
        })->store('xlsx', storage_path('exports') . '/app/reporte', true );
        return $excel;

    }

}