<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class MeasureUnit
 * @package App\Models
 * @version February 9, 2018, 12:17 pm CST
 *
 * @property \Illuminate\Database\Eloquent\Collection Item
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property string measure
 * @property boolean status
 */
class MeasureUnit extends Model
{

    public $table = 'measure_unit';
    
    public $timestamps = false;


    protected $primaryKey = 'id';

    public $fillable = [
        'measure',
        'status'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'measure' => 'string',
        'status' => 'boolean'
    ];

    public function scopeActivated($query)
    {
        return $query->where('status', '=', 1);
    }

    public function scopeDeactivated($query)
    {
        return $query->where('status', '=', 0);
    }
    
    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     **/
    public function items()
    {
        return $this->hasMany(\App\Models\Item::class);
    }
}
