<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class MethodPayment
 * @package App\Models
 * @version July 23, 2018, 4:57 pm CDT
 *
 * @property \App\Models\Coin coin
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property string key
 * @property string description
 * @property integer coin_id
 * @property string type
 * @property boolean status
 */
class MethodPayment extends Model
{

    public $table = 'method_payment';
    
    public $timestamps = false;


    protected $primaryKey = 'id';

    public $fillable = [
        'key',
        'description',
        'coin_id',
        'type',
        'status',
        'commission'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'key' => 'string',
        'description' => 'string',
        'coin_id' => 'integer',
        'type' => 'string',
        'status' => 'boolean',
        'commission' => 'integer'
    ];

    public function scopeActivated($query)
    {
        return $query->where('status', '=', 1);
    }

    public function scopeDeactivated($query)
    {
        return $query->where('status', '=', 0);
    }

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function coin()
    {
        return $this->belongsTo(\App\Models\Coin::class);
    }
}
