<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;



/**
 * Class Owner
 * @package App\Models
 * @version July 22, 2018, 1:11 pm CDT
 *
 * @property string name
 */
class Owner extends Authenticatable
{
    use Notifiable;

    public $table = 'owner';
    
    public $timestamps = false;
    
    protected $primaryKey = 'id';

    public $fillable = [
        'name',
        'key',
        'username',
        'password',
        'email',
        'phone',
        'status'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password'
    ];


    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];
    
    /**
    * @return \Illuminate\Database\Eloquent\Relations\HasMany
    **/
   public function car()
   {
       return $this->hasMany(\App\Models\Car::class);
   }

    
}
