<?php

namespace App\Models;

use Eloquent as Model;
use Illuminate\Database\Eloquent\SoftDeletes;

/**
 * Class Rate
 * @package App\Models
 * @version July 19, 2018, 11:11 am CDT
 *
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property string destination
 * @property string locality
 * @property float cost
 * @property string status
 */
class Rate extends Model
{

    use SoftDeletes;

    public $table = 'rate';
    
    public $timestamps = true;
    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';


    protected $dates = ['deleted_at','updated_at','created_at'];

    protected $primaryKey = 'id';

    public $fillable = [
        'destination',
        'locality',
        'cost',
        'status',
        'measure_unit_id',
        'sat_item_id',
        'sat_unit_id',
        'created_at',
        'update_at',
        'deleted_at'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'destination' => 'string',
        'locality' => 'string',
        'cost' => 'float',
        'status' => 'string',
        'measure_unit_id' => 'integer',
        'sat_item_id' => 'integer',
        'sat_unit_id ' => 'integer',
        'created_at'=> "dateTime",
        'update_at'=> "dateTime",
        'deleted_at' => "dateTime | null"
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    
}
