<?php

namespace App\Models;
use Curl;
use SoapClient;
use Illuminate\Support\Facades\Log;


class SoapCalls
{


    public static function cancelInvoice($number_ticket)
    {
        /*dd(env('USER'));
        dd(env('API_URL_PRODUCTION'));*/

        $url = env('APP_ENV') == 'local' ? env('API_URL_LOCAL') : env('API_URL_PRODUCTION');
        $client = new SoapClient($url . '/soap/facturas?wsdl', ["cache_wsdl" => WSDL_CACHE_NONE, "trace" => true]);


        $params = [
            'usuario' => env('APP_ENV') == 'local' ? 'LAN7008173R5' : env('USER_TIM'),//'gruas_sanjuan',
            'pass' => env('APP_ENV') == 'local' ? 'XkioEr563' : env('PASS_TIM'), //'Isotech00711',//'EsaaL3JNa',
            'folio' => $number_ticket,
            'razon' => ''
        ];


        try {

            $client->__soapCall("cancelInvoice", array($params));
            $response = $client->__getLastResponse();

            $soapXml = new \DOMDocument();
            $soapXml->loadXML($response);
            $soapDoc = $soapXml->documentElement;

            $xmlAcuse = $soapDoc->getElementsByTagName("xmlAcuse");
            $pdfAcuse = $soapDoc->getElementsByTagName("pdfAcuse");
            $pdfCancelado = $soapDoc->getElementsByTagName("pdfCancelado");
            $message = $soapDoc->getElementsByTagName("response_cancel_message");


            return [
                "success" => true,
                "xmlAcuse" => (string)$xmlAcuse[0]->nodeValue,
                "pdfAcuse" => (string)$pdfAcuse[0]->nodeValue,
                "pdfCancelado" => (string)$pdfCancelado[0]->nodeValue,
                "message" => (string)$message[0]->nodeValue
            ];


        } catch (\Exception $e) {


            return [
                "success" => false,
                "xmlAcuse" => null,
                "pdfAcuse" => null,
                "pdfCancelado" => null,
                "message" => "Ocurrió un error al cancelar su factura. " . $e->getMessage()
            ];


        }


    }

    public static function getInvoice($file)
    {

        $url = env('APP_ENV') == 'local' ? env('API_URL_LOCAL') : env('API_URL_PRODUCTION');
        $client = new SoapClient($url . '/soap/facturas?wsdl', ["cache_wsdl" => WSDL_CACHE_NONE, "trace" => true]);

      
        $params = [
            'usuario' => env('APP_ENV') == 'local' ? 'LAN7008173R5' : env('USER_TIM'),//'gruas_sanjuan',
            'pass' => env('APP_ENV') == 'local' ? 'XkioEr563' : env('PASS_TIM'),//'Isotech00711',//'EsaaL3JNa',
            'file' => base64_encode(file_get_contents($file)),
        ];
        Log::info($params);
        try {
            $client->__soapCall("doInvoice", array($params));
            $response = $client->__getLastResponse();
            Log::info('Response SOAP');
            Log::info($response);
            $soapXml = new \DOMDocument();
            $soapXml->loadXML($response);
            $soapDoc = $soapXml->documentElement;
            $xml = $soapDoc->getElementsByTagName("fileXml");
            $pdf = $soapDoc->getElementsByTagName("filePdf");
            $message = $soapDoc->getElementsByTagName("response_message");

            return [
                "success" => true,
                "xml" => (string)$xml[0]->nodeValue,
                "pdf" => (string)$pdf[0]->nodeValue,
                "message" => (string)$message[0]->nodeValue
            ];


        } catch (\Exception $e) {

            return [
                "success" => false,
                "xml" => null,
                "pdf" => null,
                "message" => "Ocurrió un error al generar su factura, contacte a PERMISIONARIOS DE QUERÉTARO A.C.  " . $e
            ];


        }

    }


    public static function readCfdi($file){
        $urlAPI = env('APP_ENV') == 'local' ? env("API_LOCAL") : env("API_PRODUCTION");
        $curl = Curl::to($urlAPI . '/miscellaneous/readCfdi')
        ->asJson(true)
        ->withData(["file" => base64_encode($file)])
        ->returnResponseObject()
        ->post();

        return $curl;
    }
}
