<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class TaxItemConfig
 * @package App\Models
 * @version January 29, 2018, 6:01 pm UTC
 *
 * @property \App\Models\TaxConfig taxConfig
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer tax_config_id
 * @property integer tax_id
 */
class TaxItemConfig extends Model
{

    public $table = 'tax_item_config';

    public $timestamps = false;



    public $fillable = [
        'tax_config_id',
        'tax_id'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'tax_config_id' => 'integer',
        'tax_id' => 'integer'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static function rules($taxItems)
    {

        $rules = [];
        $num = count($taxItems["tax_id"]);
        for ($i = 0; $i < $num; ++$i)
            $rules["tax_item_config.tax_id." . $i] = 'integer';

        return $rules;

    }

    public static function messages($taxItems)
    {
        $messages = [];
        $num = count($taxItems["tax_id"]);

        for ($i = 0; $i < $num; ++$i)
            $messages["tax_item_config.tax_id." . $i . '.integer'] = 'El impuesto #' . ($i + 1) . ' no es válido';


        return $messages;
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function taxConfig()
    {
        return $this->belongsTo(\App\Models\TaxConfig::class);
    }
}
