<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class TicketGlobalItem
 * @package App\Models
 * @version June 8, 2018, 9:28 am CDT
 *
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer ticket_global_id
 * @property integer ticket_related_id
 * @property date date_bond
 */
class TicketGlobalItem extends Model
{

    public $table = 'ticket_global_item';

    public $timestamps = false;



    public $fillable = [
        'ticket_global_id',
        'ticket_related_id',
        'date_bond'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'ticket_global_id' => 'integer',
        'ticket_related_id' => 'integer',
        'date_bond' => 'date_format:Y-m-d'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [];

    public function relatedTicket()
    {
        return $this->belongsTo(\App\Models\Ticket::class, 'ticket_related_id', 'id');
    }


}
