<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class TicketItem
 * @package App\Models
 * @version January 29, 2018, 6:04 pm UTC
 *
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer ticket_id
 * @property integer item_id
 * @property float quantity
 * @property float price
 * @property float amount
 */
class TicketItem extends Model
{

    public $table = 'ticket_item';

    public $timestamps = false;



    public $fillable = [
        'ticket_id',
        'car_id',
        'item_id',
        'quantity',
        'description',
        'price',
        'price_mx',
        'iva',
        'iva_mx',
        'amount',
        'amount_mx',
        'discount',
        'discount_mx'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'ticket_id' => 'integer',
        'car_id' => 'integer',
        'item_id' => 'integer',
        'quantity' => 'float',
        'description' => 'string',
        'price' => 'float',
        'price_mx' => 'float',
        'iva' => 'float',
        'iva_mx' => 'float',
        'amount' => 'float',
        'amount_mx' => 'float',
        'discount' => 'float',
        'discount_mx' => 'float'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [];

    /**
     * @return mixed
     */
    public function item()
    {
        return $this->hasOne(\App\Models\Rate::class,"id","item_id")->withTrashed();
    }

    /**
     * @return mixed
     */
    public function car()
    {
        return $this->belongsTo(\App\Models\Car::class);
    }
}
