<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class TicketMethodPayment
 * @package App\Models
 * @version July 30, 2018, 9:50 am CDT
 *
 * @property \App\Models\Ticket ticket
 * @property \App\Models\MethodPayment methodPayment
 * @property \App\Models\ExchangeRate exchangeRate
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection ticketItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer ticket_id
 * @property integer method_payment_id
 * @property integer exchange_rate_id
 * @property float amount
 */
class TicketMethodPayment extends Model
{

    public $table = 'ticket_method_payment';
    
    public $timestamps = false;

    protected $primaryKey = 'id';

    public $fillable = [
        'ticket_id',
        'method_payment_id',
        'exchange_rate_id',
        'amount',
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'ticket_id' => 'integer',
        'method_payment_id' => 'integer',
        'exchange_rate_id' => 'integer',
        'amount' => 'float',
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function ticket()
    {
        return $this->belongsTo(\App\Models\Ticket::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function methodPayment()
    {
        return $this->belongsTo(\App\Models\MethodPayment::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function exchangeRate()
    {
        return $this->belongsTo(\App\Models\ExchangeRate::class);
    }
}
