<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class TicketPay
 * @package App\Models
 * @version August 31, 2018, 5:42 am CDT
 *
 * @property \App\Models\Ticket ticket
 * @property \App\Models\UserShift userShift
 * @property \Illuminate\Database\Eloquent\Collection cashOutbound
 * @property \Illuminate\Database\Eloquent\Collection ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer user_shift_id
 * @property integer ticket_id
 * @property string|\Carbon\Carbon created_at
 */
class TicketPay extends Model
{
    const UPDATED_AT = null;
    const CREATED_AT = 'created_at';
    public $table = 'ticket_pay';
    
    public $timestamps = true;



    public $fillable = [
        'user_shift_id',
        'ticket_id',
        'created_at'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'user_shift_id' => 'integer',
        'ticket_id' => 'integer'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function ticket()
    {
        return $this->belongsTo(\App\Models\Ticket::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function userShift()
    {
        return $this->belongsTo(\App\Models\UserShift::class);
    }
}
