<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class UserShift
 * @package App\Models
 * @version August 16, 2018, 3:17 pm CDT
 *
 * @property \App\Models\User user
 * @property \Illuminate\Database\Eloquent\Collection Ticket
 * @property \Illuminate\Database\Eloquent\Collection ticketGlobalItem
 * @property \Illuminate\Database\Eloquent\Collection user
 * @property integer user_id
 * @property string|\Carbon\Carbon start_shift_date
 * @property string|\Carbon\Carbon final_shift_date
 * @property string|\Carbon\Carbon created_at
 */
class UserShift extends Model
{

    public $table = 'user_shift';
    
    public $timestamps = false;



    public $fillable = [
        'user_id',
        'cash_register_id',
        'start_shift_date',
        'final_shift_date',
        "init_amount",
        "note"
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'user_id' => 'integer',
        'cash_register_id' => 'integer',
        "note"=> "string",
        "init_amount"=>"float",
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        
    ];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function user()
    {
        return $this->belongsTo(\App\Models\User::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     **/
    public function cashRegister()
    {
        return $this->belongsTo(\App\Models\CashRegister::class);
    }


    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     **/
    public function tickets()
    {
        return $this->hasMany(\App\Models\Ticket::class,"shift_user_id");
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     **/
    public function cashOutbound()
    {
        return $this->hasMany(\App\Models\CashOutbound::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     **/
    public function pay()
    {
        return $this->hasMany(\App\Models\TicketPay::class);
    }
}
