<?php

namespace App\Providers;

use App\Models\UserShift;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\ServiceProvider;
use Illuminate\Support\Facades\Log;

class AppServiceProvider extends ServiceProvider
{
    /**
     * Bootstrap any application services.
     *
     * @return void
     */
    public function boot()
    {
        \Form::macro('btnShift',function(){
            $id_user = Auth::user()->id;

            $activedShift = UserShift::where("user_id","=",$id_user)
                                ->orderBy("start_shift_date","desc")
                                ->where("final_shift_date","=",null)->first();

            Log::info($activedShift);
            $title = !$activedShift ?"Iniciar Turno": "Cerrar Turno";
            Log::info($title);
            $class = !$activedShift ?"btn btn-primary": "btn btn-danger";
            Log::info($class);
            $icon = !$activedShift ?"fa fa-clock-o": "fa fa-calendar-times-o";
            Log::info($icon);
            $method = !$activedShift ? "POST": "PUT";
            Log::info($method);
            $route = !$activedShift ? route("userShifts.store"): route("userShifts.update",$activedShift["id"]);
            Log::info($route);


            return \Form::button("<span><i class='".$icon."'></i></span> ".$title,
                    ["name"=>"btnShift","class"=>$class,"data-route"=> $route,"data-method"=>$method,
                        "data-get_shift"=>route("userShifts.getClose"),
                        "data-get_cr_disponible"=>route("userShifts.getCRDisponible")]);
        });
        //

        \Form::macro('_method',function(){
            $id_user = Auth::user()->id;

            $activedShift = UserShift::where("user_id","=",$id_user)
                ->orderBy("start_shift_date","desc")
                ->where("final_shift_date","=",null)->first();

            $method = ($activedShift == null)?"POST": "PATCH";


            return \Form::text("_method",$method,["class"=>"hidden"]);
        });
    }

    /**
     * Register any application services.
     *
     * @return void
     */
    public function register()
    {
        //
    }
}
