$(document).ready(function () {
    $("select").select2();
    $("#formCar").parsley();
    $("#formOutbound").parsley();

    $("#filterOwner").val(null).change();

    $('#dataTableBuilder').on('preXhr.dt', function (e, settings, data) {
        data.owner = $('#filterOwner').val();
    });

    $("#filterOwner").on("change", function () {
        $('.buttons-reload').click();
    });
    
    //Open modal to create an owner
    $(document).on("click", "#newCar", function () {
        $('#formCar').parsley().reset();
        document.getElementById("formCar").reset();
        $("#id").val('');
        $("#selectOwner").val('').change();
        $("#formCar").data('action', 'create');
        $("#modalTitle").text('Nuevo Auto');
        $("#modalCar").modal("show");

        return false;
    });

    //Open modal to edit a owner
    $(document).on("click", "#editCar", function () {
        $('#formCar').parsley().reset();
        document.getElementById("formCar").reset();
        $("#formCar").data('action', 'edit');
        $("#id").val($(this).data('id'));
        $("input[name='name']").val($(this).data('name'));
        $("textarea[name='description']").val($(this).data('description'));
        $("#selectOwner").val($(this).data('owner')).change();
        $("#modalTitle").text('Editar Auto');
        $("#modalCar").modal('show');

        return false;
    });

    $("#formCar").on("submit", function (e) {
        var valid = $("#formCar").parsley().isValid();

        if (valid) {
            saveCar();
        }

        return false;
    });

    $(document).on('click', '#deleteCar', function () {
        $.ajaxDelete({
            crud: 'Autos',
            question: '¿Está seguro de eliminar el auto: <b class="text-danger">' + $(this).data('name') + '</b>?',
            url: '/cars/' + $(this).data('id'),
            loadingSelector: ".carBody",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {
            }
        });
    });

    //Open modal to Outbound
    $(document).on("click", "#addOutbound", function () {
        var route = $(this).data("route");
        var check = $(this).data("check");
        $("#id_car").val($(this).data('id'));

        var params = {
            crud: 'Taxis',
            type: 'GET',
            url: check,
            form: "",
            loadingSelector: "#modalOwner .modal-body",
            successCallback: function (data) {
                console.log(data);

                $('#formOutbound').parsley().reset();
                document.getElementById("formOutbound").reset();

                $('#createOutbound').data("route",route);
                $("#modalTitle").text('Nueva salida a '+$(this).data("name"));
                $("#modalOutbound").modal("show");

            },
            errorCallback: function (data) {
            }
        };
        $.ajaxSimple(params);



        return false;
    });

    $("#createOutbound").on("click", function (e) {
        var valid = $("#formOutbound").parsley().isValid();
        var route = $(this).data("route");

        if (valid) {
            saveOutbound(route);
        }

        return false;
    });


    function saveCar() {
        $("input[name='_method']").val($("#formCar").data("action") == 'create' ? 'POST' : 'PATCH');
        
        var url = $("#DATA").data("url") + '/cars';

        $.ajaxFormData({
            crud: 'Autos',
            type: 'POST',
            url: $("#formCar").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formCar",
            loadingSelector: "#modalCar .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalCar").modal("hide");
            },
            errorCallback: function (data) {
            }
        });
    }

    function saveOutbound(route) {
        $("input[name='_method']").val('POST');


        console.log(route);

        $.ajaxFormData({
            crud: 'Outbound',
            type: 'POST',
            url: route,
            form: "formOutbound",
            loadingSelector: "#modalOutbound .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalOutbound").modal("hide");
            },
            errorCallback: function (data) {
            }
        });
    }
});