$(document).ready(function () {
    $("select").select2();
    $("#selectCoin").val(null).change();
    $("#selectStatus").val('1').change();

    $('#dataTableBuilder').on('preXhr.dt', function (e, settings, data) {
        data.coin = $('#selectCoin').val();
        data.status = $('#selectStatus').val();
    });

    $("#selectStatus, #selectCoin").on("change", function () {
        $('.buttons-reload').click();
    });

    $("#formExchangeRate").parsley();
    
    //Open modal to update exchange rates
    $(document).on("click", "#updateExchangeRate", function () {
        getCurrent();
        $("#formExchangeRate").data('action', 'create');
        $("#modalTitle").text('Actualizar Tipo de Cambio');
        $("#modalExchangeRate").modal("show");

        return false;
    });
    
    $(document).on("click", "#deleteExchangeRate", function () {
        var coin = $(this).parents('td').siblings('td:first-child').children('span').text().split(':')[0];

        if (confirm('¿Desea descartar el tipo de cambio para ' + coin + '?')) {
            $(this).parents('tr').remove();
        }

        return false;
    });

    $("#formExchangeRate").on("submit", function (e) {
        var valid = $("#formExchangeRate").parsley().isValid();

        if (valid) {
            saveExchangeRate();
        }

        return false;
    });

    function saveExchangeRate() {
        $("input[name='_method']").val($("#formExchangeRate").data("action") == 'create' ? 'POST' : 'PATCH');
        
        var url = $("#DATA").data("url") + '/exchangeRates';

        $.ajaxFormData({
            crud: 'Tipo de Cambio',
            type: 'POST',
            url: $("#formExchangeRate").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formExchangeRate",
            loadingSelector: "#modalExchangeRate .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalExchangeRate").modal("hide");
            },
            errorCallback: function (data) {
            }
        });
    }

    function getCurrent(id, status) {
        var url = $("#DATA").data("url") + '/exchangeRates/getCurrent';
        $.ajaxSimple({
            crud: 'Tipo de Cambio',
            type: 'GET',
            url: url,
            form: "formExchangeRate",
            loadingSelector: "#modalExchangeRate .modal-body",
            successCallback: function (data) {
                var html = "";
                $("#tBodyExchangeRate").html("");

                $.each(data.exchangeRates, function (key, val) {
                    html += '<tr>' +
                        '<td>' +
                            '<input type="hidden" name="coin_id[]" value="' + val.coin_id + '"/>' +
                            '<span class="badge badge-inverse">' + val.coin.key + ' : ' + val.coin.description + '</span>' +
                        '</td>' +
                        '<td class="form-group">' +
                            '<input type="number" class="form-control input-sm tcMxn" required name="exchange_rate[]" value="' + val.exchange_rate + '" />' + 
                        '</td>' +
                        '<td class="text-center">' + 
                            '<button id="deleteExchangeRate" class="btn btn-danger btn-icon btn-circle btn-lg"><i class="fa fa-trash"></i></button>' +
                        '</td>' +
                    '</tr>';

                });

                $("#tBodyExchangeRate").html(html);
            },
            errorCallback: function (data) {

            }

        });
    }
});