$(document).ready(function () {

    $("select").select2({ language: 'es' });

    //Open modal to manage a filial
    $(document).on("click", "#openFilialModal", function () {

        document.getElementById("formFilial").reset();
        $("select").val('').trigger('change');
        $("#id").val('');
        $("#formFilial").data('action', 'create');
        $("#modalTitle").text('Nueva Sucursal');
        $("#modalFilial").modal("show");
        return false;

    });

    //Open modal to edit a filial
    $(document).on("click", "#editFilial", function () {
        $("#formFilial").data('action', 'edit');
        $("#id").val($(this).data('id'));
        $("#modalTitle").text('Editar Sucursal');
        getFilial($(this).data('id'));
        return false;


    });

    //Activate filial
    $(document).on('click', '#activateFilial', function () {

        if (confirm('¿Está seguro(a) de activar la sucursal?'))
            activateDeactive($(this).data("id"), 1);

        return false;
    });

    //Deactivate filial
    $(document).on('click', '#deactivateFilial', function () {
        if (confirm('¿Está seguro(a) de desactivar la sucursal ?'))
            activateDeactive($(this).data("id"), 0);
        return false;

    });


    //Save Filial Data via AJAX Request
    $("#formFilial").on("submit", function (e) {

        var valid = $("#formFilial").parsley().isValid();
        if (valid) {
            saveFilial();
        }
        return false;

    });


    function saveFilial() {

        $("input[name='_method']").val($("#formFilial").data("action") == 'create' ? 'POST' : 'PATCH');


        var url = $("#DATA").data("url") + '/filials';
        $.ajaxFormData({
            crud: 'Sucursales',
            type: 'POST',
            url: $("#formFilial").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formFilial",
            loadingSelector: "#modalFilial .modal-body",
            successCallback: function (data) {


                $(".buttons-reload").click();
                $("#modalFilial").modal("hide");


            },
            errorCallback: function (data) {

            }

        });
    }

    //Get selected filial's information
    function getFilial($id) {

        $.ajaxSimple({
            crud: 'Sucursales',
            type: 'GET',
            url: $("#DATA").data("url") + '/filials/' + $id + '/edit',
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {

                $("#modalFilial").modal("show");
                $("input[name='name']").val(data.filial.name);
                $("input[name='prefix']").val(data.filial.prefix);
                $("input[name='number_ticket']").val(data.filial.number_ticket);
                $("input[name='phone']").val(data.filial.phone);
                $("input[name='email']").val(data.filial.email);

                $("input[name='street']").val(data.filial.street);
                $("input[name='ext']").val(data.filial.ext);
                $("input[name='int']").val(data.filial.int);
                $("input[name='suburb']").val(data.filial.suburb);
                $("input[name='zip_code']").val(data.filial.zip_code);
                $("input[name='council']").val(data.filial.council);
                $("input[name='polity']").val(data.filial.polity);

              
            },
            errorCallback: function (data) {

            }
        });


    }

    //Can activate/deactivate a filial via AJAX Request
    function activateDeactive(id, status) {

        $.ajaxSimple({
            crud: 'Sucursales',
            type: 'GET',
            url: $("#DATA").data("url") + '/filials/setStatus/' + id + '/' + status,
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {

            }
        });
    }


});