$(document).ready(function () {

    $("select").select2({ language: 'es' });
    //Autocomplete Sat Item
    $("#autocompleteItem").autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'GET',
                dataType: 'json',
                url: $("#DATA").data("api") + '/satItems/searchItem/' + request.term,
                success: function (data) {
                    var results = [];
                    $.each(data.satItems, function (key, val) {
                        results.push({ value: val.id_sat_producto, label: val.clave + ':' + val.descripcion });
                    });
                    response(results);
                }
            });
        },
        select: function (event, ui) {
            $(this).val(ui.item.label);
            $("input[name='sat_item_id']").val(ui.item.value);
            return false;
        },
        appendTo: "#modalItem",
    });

    //Autocomplete Sat Unit
    $("#autocompleteUnit").autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'GET',
                dataType: 'json',
                url: $("#DATA").data("api") + '/satUnits/searchUnit/' + request.term,
                success: function (data) {
                    var results = [];
                    $.each(data.satUnits, function (key, val) {
                        results.push({ value: val.id_sat_unidad, label: val.clave + ':' + val.nombre });
                    });
                    response(results);
                }
            });
        },
        select: function (event, ui) {
            $(this).val(ui.item.label);
            $("input[name='sat_unit_id']").val(ui.item.value);


            return false;
        },
        appendTo: "#modalItem",
    });

    $("#formItem").parsley();
    //Open modal to create an item
    $(document).on("click", "#openModalItem", function () {

        document.getElementById("formItem").reset();
        $("select[name='measure_unit_id']").val('').trigger("change");
        $("#id").val('');
        $("#formItem").data('action', 'create');
        $("#modalTitle").text('Nuevo Producto/Servicio');
        $("#modalItem").modal("show");

        return false;

    });

    //Open modal to edit an item
    $(document).on("click", "#editItem", function () {
        document.getElementById("formItem").reset();
        $("#formItem").data('action', 'edit');
        $("#id").val($(this).data('id'));
        $("#modalTitle").text('Editar Producto/Servicio');

        getItemInfo($(this).data('id'));
        return false;


    });

    //Activate item
    $(document).on('click', '#activateItem', function () {

        if (confirm('¿Está seguro(a) de activar este producto/servicio?'))
            activateDeactive($(this).data("id"), 1);

        return false;
    });

    //Deactivate item
    $(document).on('click', '#deactivateItem', function () {
        if (confirm('¿Está seguro(a) de desactivar este producto/servicio?'))
            activateDeactive($(this).data("id"), 0);
        return false;

    });


    //Save item via AJAX
    $("#formItem").on("submit", function (e) {

        var valid = $("#formItem").parsley().isValid();
        if (valid) {
            saveItem();
        }
        return false;

    });


    function saveItem() {

        $("input[name='_method']").val($("#formItem").data("action") == 'create' ? 'POST' : 'PATCH');
        var url = $("#DATA").data("url") + '/items';
        $.ajaxFormData({
            crud: 'Productos/Servicios',
            type: 'POST',
            url: $("#formItem").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formItem",
            loadingSelector: "#modalItem .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalItem").modal("hide");
            },
            errorCallback: function (data) {
            }
        });
    }

    //Function to get item info
    function getItemInfo($id) {

        $.ajaxSimple({
            crud: 'Productos/Servicios',
            type: 'GET',
            url: $("#DATA").data("url") + '/items/' + $id + '/edit',
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {
                $("#modalItem").modal("show");
                $("input[name='name']").val(data.item.name);
                $("input[name='sku']").val(data.item.sku);
                $("select[name='measure_unit_id']").val(data.item.measure_unit_id).trigger("change");
                $("input[name='price']").val(data.item.price);

                $("#autocompleteItem").val(data.satItem.clave + ':' + data.satItem.descripcion);
                $("#autocompleteUnit").val(data.satUnit.clave + ':' + data.satUnit.nombre);

                $("input[name='sat_item_id']").val(data.satItem.id_sat_producto);
                $("input[name='sat_unit_id']").val(data.satUnit.id_sat_unidad);
            },
            errorCallback: function (data) {

            }
        });

    }



    //Function to activate/deactivate an item
    function activateDeactive(id, status) {

        $.ajaxSimple({
            crud: 'Productos/Servicios',
            type: 'GET',
            url: $("#DATA").data("url") + '/items/setStatus/' + id + '/' + status,
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {

            }
        });
    }
});