$(document).ready(function () {

    $("#formTax").parsley();
    //Open modal to create a tax config
    $(document).on("click", "#openModalTax", function () {

        document.getElementById("formTax").reset();
        $("#id").val('');
        $("#formTax").data('action', 'create');
        $("#modalTitle").text('Nueva Configuración de Impuestos');
        $("#modalTax").modal("show");

        return false;

    });

    //Open modal to edit a tax config
    $(document).on("click", "#editTax", function () {
        $("#formTax").data('action', 'edit');

        $("#id").val($(this).data('id'));
        $("#modalTitle").text('Editar Configuración de Impuestos');

        getTaxes($(this).data('id'));

        return false;


    });

    //Activate tax
    $(document).on('click', '#activateTax', function () {

        if (confirm('¿Está seguro(a) de activar esta configuración?'))
            activateDeactive($(this).data("id"), 1);

        return false;
    });

    //Deactivate tax
    $(document).on('click', '#deactivateTax', function () {
        if (confirm('¿Está seguro(a) de desactivar esta configuración?'))
            activateDeactive($(this).data("id"), 0);
        return false;

    });


    //Save tax via AJAX
    $("#formTax").on("submit", function (e) {

        var valid = $("#formTax").parsley().isValid();
        if (valid) {
            saveTax();
        }
        return false;

    });


    function saveTax() {

        if ($("#tbTaxes tbody tr").length == 0) {
            toastr.error("Debe indicar al menos 1 impuesto", "Configuración de Impuestos");
            return false;
        }
        $("input[name='_method']").val($("#formTax").data("action") == 'create' ? 'POST' : 'PATCH');
        var url = $("#DATA").data("url") + '/taxConfigs';
        $.ajaxFormData({
            crud: 'Configuración de Impuestos',
            type: 'POST',
            url: $("#formTax").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formTax",
            loadingSelector: "#modalTax .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalTax").modal("hide");

                $("#tbTaxes tbody").html("");
            },
            errorCallback: function (data) {
            }
        });
    }

    //Function to get the taxes from the API
    function getTaxes($id) {

        $.ajaxSimple({
            crud: 'Configuración de Impuestos',
            type: 'GET',
            url: $("#DATA").data("url") + '/taxConfigs/' + $id + '/edit',
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {

                var html = '';
                $.each(data.taxes.federalTaxes, function (key, val) {
                    html += taxRow(val.id_impuesto_federal, val.impuesto, 'ajax');
                });

                $("input[name='tax_config[name]']").val(data.taxConfig.name);
                $("#tbTaxes tbody").html(html);
                $("#modalTax").modal("show");
            },
            errorCallback: function (data) {

            }
        });

    }


    //Function to activate/deactivate tax config
    function activateDeactive(id, status) {

        $.ajaxSimple({
            crud: 'Configuración de Impuestos',
            type: 'GET',
            url: $("#DATA").data("url") + '/taxConfigs/setStatus/' + id + '/' + status,
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {

            }
        });
    }
});
//Function html code to put in the taxes's table 
function taxRow($id, $tax, $type) {
    return '<tr>' +
        '<td>' +
        '<span class="badge badge-success">' + $tax + '</span>' +
        '<input type="hidden" name="tax_item_config[tax_id][]" class="form-control" value="' + $id + '" />' +
        '</td>' +
        '<td><button type="button"  id="deleteTax" data-id="' + $id + '" data-type="' + $type + '" class="btn btn-danger btn-sm"><i class="fa fa-trash"></i></button></td>' +
        '</tr>';
}

$(function () {

    $("#tbTaxes tbody").html("");
    $("#jquery-autocomplete").autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'GET',
                dataType: 'json',
                url: $("#DATA").data("api") + '/taxes/searchFederal/' + request.term,
                success: function (data) {
                    var results = [];
                    $.each(data.federalTaxes, function (key, val) {
                        results.push({ value: val.id_impuesto_federal, label: val.impuesto });
                    });
                    response(results);
                }
            });
        },
        select: function (event, ui) {
            $(this).val('');
            //Search tax on table
            var add = true;
            $("#tbTaxes tbody tr").each(function () {
                if ($(this).find("td:first-child").text() == ui.item.label)
                    add = false;
                return true;
            });
            if (add)
                $("#tbTaxes tbody").append(taxRow(ui.item.value, ui.item.label, 'noAjax'));

            return false;
        },
        appendTo: "#modalTax",
    });


    //Delete tax from table
    $(document).on("click", "#deleteTax", function () {
        var id = $(this).data("id"), tax_config_id = $("#formTax #id").val(), row = this;
        if (confirm('¿Está seguro(a) de eliminar este impuesto ?')) {

            if ($(this).data("type") == 'noAjax')
                $(this).parents("tr").remove();
            else {

                $.ajaxSimple({
                    type: 'GET',
                    url: $("#DATA").data("url") + '/taxItemsConfig/deleteTax/' + tax_config_id + '/' + id,
                    form: "",
                    loadingSelector: "#tbTaxes",
                    crud: "Configuración de impuestos",
                    successCallback: function () {
                        row.parents("tr").remove();
                    },
                    errorCallback: function () {

                    }


                });
            }
        }
        return false;
    });




}); 