$(document).ready(function () {
    $("select").select2();
    $("#selectRate").select2({language: 'es'});

    $("#filterStatus").val(null).change();

    $('#dataTableBuilder').on('preXhr.dt', function (e, settings, data) {
        data.status = $('#filterStatus').val();
    });

    $("#filterStatus").on("change", function () {
        $('.buttons-reload').click();
    });

    $('#selectRate').change(function(){
        $(this).find("option:selected").each(function(){
            var value = $(this).attr("value");            
            value == "local" ? $('#groupLocality').hide() : $('#groupLocality').show();
        });
    });

    $("#formRate").parsley();

    $("#openUploadModal").on("click",function () {
        console.log("entro");
        $("#UploadRatesModal").modal("show");

    });

    $("#fileImport").fileinput({
        language: 'es',
        showUpload: false,
        allowedFileExtensions: ['xlsx', 'xls']
    });

    $("#btnUploadFile").on('click', function () {
        var route = $(this).data("route");
        $.ajaxFormData({
            crud: 'Tarifas',
            type: 'POST',
            url: route,
            form: 'frmImportProductos',
            loadingSelector: $("#loading-table"),
            successCallback: function (data) {
                $(".fileinput-remove").click();
                $("#lblNoWorkers").text(parseFloat(data.workers).toMoney(0, '.', ','));
                $("#errorBody").empty();
                $.each(data.error, function (index, value) {
                    $("#errorBody").append('<div class="alert alert-danger fade in m-b-15">\
                        <strong>' + index + '</strong>\
                        ' + value + '\
                        <span class="close" data-dismiss="alert">&times;</span>\
                    </div>');
                });
            },
            errorCallback: function (data) {
            }
        });
    });


    //Open modal to create an rate
    $(document).on("click", "#newRate", function () {
        $('#formRate').parsley().reset();
        document.getElementById("formRate").reset();
        $("#id").val('');
        $("#selectRate").val('').change();
        $("#formRate").data('action', 'create');
        $("#modalTitle").text('Nueva Tarifa');
        $("#modalRate").modal("show");

        return false;
    });

    //Open modal to edit a rate
    $(document).on("click", "#editRate", function () {
        $('#formRate').parsley().reset();
        document.getElementById("formRate").reset();
        $("#formRate").data('action', 'edit');
        $("#id").val($(this).data('id'));
        $("input[name='cost']").val($(this).data('cost'));
        $("input[name='destination']").val($(this).data('destination'));
        $("input[name='locality']").val($(this).data('locality'));
        $("#selectRate").val($(this).data('status')).change();
        $("#modalTitle").text('Editar Tarifa');
        $("#modalRate").modal('show');

        return false;
    });

    $("#formRate").on("submit", function (e) {
        var valid = $("#formRate").parsley().isValid();

        if (valid) {
            saveRate();
        }

        return false;
    });

    $(document).on('click', '#deleteRate', function () {
        $.ajaxDelete({
            crud: 'Tarifas',
            question: '¿Eliminar esta Tarifa?',
            url: '/rates/' + $(this).data('id'),
            loadingSelector: ".rateBody",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {
            }
        });
    });

    function saveRate() {
        $("input[name='_method']").val($("#formRate").data("action") == 'create' ? 'POST' : 'PATCH');
        
        var url = $("#DATA").data("url") + '/rates';

        $.ajaxFormData({
            crud: 'Tarifas',
            type: 'POST',
            url: $("#formRate").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formRate",
            loadingSelector: "#modalRate .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalRate").modal("hide");
            },
            errorCallback: function (data) {
            }
        });
    }
});