$(document).ready(function () {

    $("#formTax").parsley();
    //Open modal to create a tax config
    $(document).on("click", "#openModalTax", function () {

        document.getElementById("formTax").reset();
        $("#id").val('');
        $("#formTax").data('action', 'create');
        $("#modalTitle").text('Nueva Configuración de Impuestos');
        $("#modalTax").modal("show");

        return false;

    });

    //Open modal to edit a tax config
    $(document).on("click", "#editTax", function () {
        $("#formTax").data('action', 'edit');

        $("#id").val($(this).data('id'));
        $("#modalTitle").text('Editar Configuración de Impuestos');

        getTaxes($(this).data('id'));

        return false;


    });

    //Activate tax
    $(document).on('click', '#activateTax', function () {

        if (confirm('¿Está seguro(a) de activar esta configuración?'))
            activateDeactive($(this).data("id"), 1);

        return false;
    });

    //Deactivate tax
    $(document).on('click', '#deactivateTax', function () {
        if (confirm('¿Está seguro(a) de desactivar esta configuración?'))
            activateDeactive($(this).data("id"), 0);
        return false;

    });


    //Save tax via AJAX
    $("#formTax").on("submit", function (e) {

        var valid = $("#formTax").parsley().isValid();
        if (valid) {
            saveTax();
        }
        return false;

    });


    function saveTax() {

        if ($("#tbTaxes tbody tr").length == 0) {
            toastr.error("Debe indicar al menos 1 impuesto", "Configuración de Impuestos");
            return false;
        }
        $("input[name='_method']").val($("#formTax").data("action") == 'create' ? 'POST' : 'PATCH');
        var url = $("#DATA").data("url") + '/taxConfigs';
        $.ajaxFormData({
            crud: 'Configuración de Impuestos',
            type: 'POST',
            url: $("#formTax").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formTax",
            loadingSelector: "#modalTax .modal-body",
            successCallback: function (data) {
                $(".buttons-reload").click();
                $("#modalTax").modal("hide");

                $("#tbTaxes tbody").html("");
            },
            errorCallback: function (data) {
            }
        });
    }

    //Function to get the taxes from the API
    function getTaxes($id) {

        $.ajaxSimple({
            crud: 'Configuración de Impuestos',
            type: 'GET',
            url: $("#DATA").data("url") + '/taxConfigs/' + $id + '/edit',
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {

                var html = '';
                $.each(data.taxes.federalTaxes, function (key, val) {
                    html += taxRow(val.id_impuesto_federal, val.impuesto, 'ajax');
                });

                $("input[name='tax_config[name]']").val(data.taxConfig.name);
                $("#tbTaxes tbody").html(html);
                $("#modalTax").modal("show");
            },
            errorCallback: function (data) {

            }
        });

    }


    //Function to activate/deactivate tax config
    function activateDeactive(id, status) {

        $.ajaxSimple({
            crud: 'Configuración de Impuestos',
            type: 'GET',
            url: $("#DATA").data("url") + '/taxConfigs/setStatus/' + id + '/' + status,
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {

            }
        });
    }
});