$(function() {
  $("#frmGlobal").parsley();
  $("select").select2({ language: "es" });
  $(".stepper").TouchSpin({ min: 0, max: 1000000, step: 0.01, decimals: 2 });


  window.Parsley
    .addValidator('total', {
        requirementType: 'integer',
        validateNumber: function(value, requirement) {
            var inputs={
                subtotal:$('input[name="ticket[subtotal]"]'),
                iva:$('input[name="ticket[iva]"]'),
            };
            return ((eval(inputs.subtotal.val())+eval(inputs.iva.val())).toFixed(2)) == value;
        },
        messages: {
        es: 'Por favor ajuste el iva',
        }
    });

  $(".input-daterange input").each(function() {
    $(this).datepicker({
      language: "es",
      autoclose: true,
      format: "yyyy-mm-dd"
    });
  });

    $("#tax_percent").on("change",function () {
        var percent = $(this).val();
        applyPercent(percent)

    });

    function applyPercent(percent) {
        var subtotal = $("input[name='ticket[subtotal]']").val();
        var iva = 0;
        iva = parseFloat(percent) * parseFloat(subtotal);
        var amount =parseFloat(subtotal)+ parseFloat(iva);

        $("input[name='ticket[iva]']").val(iva.toFixed(2));
        $("input[name='ticket[amount]']").val(amount.toFixed(2));
    }

    $("button[name='checkTickets']").on("click",function () {
       var cant = $(this).data("cantidad");

       $("#tbTickets tbody tr").each(function (idx,data) {
           console.log(!$(data).find("input[name='willAdded']").is(":checked"));
          if(cant > 0){
              console.log(cant);

              var index = $(data).closest("tr");

            if(!$(data).find("input[name='willAdded']").is(":checked")) {

                $(data).find("input[name='willAdded']").prop("checked",!$(data).find("input[name='willAdded']").is(":checked"));

               $(index).find(".id_input").attr("name", "ticket[items][id][]");
               $(index).find(".sku_input").attr("name", "ticket[items][sku][]");
               $(index).find(".subtotal_input").attr("name", "ticket[items][subtotal][]");
               $(index).find(".iva_input").attr("name", "ticket[items][iva][]");
               $(index).find(".amount_input").attr("name", "ticket[items][amount][]");
               cant --;
            }
            setTotals();
          }
       })
    });

  $(document).on("click", 'input[name="willAdded"]', el => {
    $(el.target)
      .parents(".container")
      .find('input[name="setTicket[]"]')
      .val($(el.target).is(":checked"));
    var index = $(el.target).closest("tr");

    if($(el.target).is(":checked")) {
        $(index).find(".id_input").attr("name", "ticket[items][id][]");
        $(index).find(".sku_input").attr("name", "ticket[items][sku][]");
        $(index).find(".subtotal_input").attr("name", "ticket[items][subtotal][]");
        $(index).find(".iva_input").attr("name", "ticket[items][iva][]");
        $(index).find(".amount_input").attr("name", "ticket[items][amount][]");
    }else{
        $(index).find(".id_input").removeAttr("name", "ticket[items][id][]");
        $(index).find(".sku_input").removeAttr("name", "ticket[items][sku][]");
        $(index).find(".subtotal_input").removeAttr("name", "ticket[items][subtotal][]");
        $(index).find(".iva_input").removeAttr("name", "ticket[items][iva][]");
        $(index).find(".amount_input").removeAttr("name", "ticket[items][amount][]");
    }

    setTotals();
  });

  $(".stepper").on('touchspin.on.startspin',()=>{
    $("#frmGlobal").parsley().validate();
    return false;
});


  $("#searchTickets").on("click", () => {
    console.log($("#DATA").data("url"));
    const from = $("#from").val(),
      to = $("#to").val(),
      filial = $("#filial").val();

    var method_payment = $("#method_payment").val();
    var url = $("#DATA").data("url") +
        "/tickets/getGlobalTickets/" +
        filial +
        "/";

    if (!from || !to || !filial) {
      toastr.error(
        "Debe indicar el rango de fechas y la base",
        "Timbrado Global"
      );
      return false;
    }

    url += from +
        "/" +
        to;

    if(method_payment != "") {
        url += "/" + method_payment ;
    }

    $.ajaxSimple({
      crud: "Timbrado Global",
      type: "GET",
      url: url,
      form: "",
      loadingSelector: ".panel-body",
      successCallback: function(data) {
        var htmlTickets = "";
        if (data.tickets.length == 0) {
          $("#tbTickets tbody").html(
            `<tr><td colspan="6" class="text-center">No se encontraron tickets</td></tr>`
          );
          return false;
        }

        $.each(data.tickets, (key, val) => {
          htmlTickets += `
                <tr>
                    <td class="col-lg-1">
                        <label class="container">
                            <input type="checkbox" name="willAdded" />
                            <span class="checkmark"></span>
                        </label>
                    </td>
                    <td class="col-lg-2">
                        <span class="badge badge-primary" style="font-size:10px;">
                            <i class="fa fa-bookmark"></i>
                            ${val.number_ticket}
                        </span>
                        <input type="hidden" class="id_input" value="${
                          val.id
                        }"/>
                        <input type="hidden" class="sku_input" value="${
                          val.number_ticket
                        }"/>
                    </td>
                    <td class="col-lg-2">
                        ${val.dateF}
                    </td>
                    <td class="col-lg-2">
                        <input type="hidden" class="subtotal_input" value="${
                          val.subtotal_mx ? val.subtotal_mx : "0.00"
                        }"/>
                        ${val.subtotal_mx ? val.subtotal_mx : "0.00"}
                    </td>
                    <td class="col-lg-2">
                        <input type="hidden" class="iva_input" value="${
                          val.iva ? val.iva : "0.00"
                        }"/>
                        ${val.iva ? val.subtotal_mx : "0.00"}
                    </td>
                    <td class="col-lg-2">
                        <input type="hidden" class="amount_input" value="${
                          val.amount_mx ? val.amount_mx : "0.00"
                        }"/>
                        ${val.amount_mx ? $.formatNumber(val.amount_mx, 2) : "0.00"}
                    </td>
                </tr>    
            `;
        });

        $("#tbTickets tbody").html(htmlTickets);
        setTotals();
      },
      errorCallback: function(data) {}
    });
    return false;
  });

  $("#frmGlobal").on("submit", () => {
    var valid = $("#frmGlobal")
      .parsley()
      .isValid();
    var url = $("#DATA").data("url") + "/tickets/signGlobalInvoice";

    if (valid) {
      $.ajaxFormData({
        crud: "Timbrado de Factura Global",
        type: "POST",
        url: url,
        form: "frmGlobal",
        loadingSelector: ".panel-body",
        successCallback: function(data) {
          $("#tbTickets tbody").html("");
          $('select[name="filial"]')
            .val("")
            .trigger("change");
          document.getElementById("frmGlobal").reset();
          PDFObject.embed(data.file, ".pdfGlobal", {
            pdfOpenParams: { view: "FitVH", page: "1" }
          });

          $("#modalGlobalPdf").modal("show");
          $("#globalSubtotal,#globalIva").text();

        },
        errorCallback: function(data) {}
      });
    }
    return false;
  });

  function setTotals() {
    var totals = { subtotal: 0, iva: 0, amount: 0 };


      $.each($("#tbTickets tbody tr"),function (index, el) {
        if($(el).find("input[type='checkbox']").is(":checked")){
          const row = $(el);
            totals.subtotal += eval(
                row.find(".subtotal_input").val()
            );
            totals.iva += eval(
                row.find(".iva_input").val()
            );
            totals.amount += eval(
                row.find(".amount_input").val()
            );
        }

      });
    

    $("#globalSubtotal").text(`${totals.subtotal.toFixed(4)}`);
    $("#globalIva").text(`${totals.iva.toFixed(4)}`);


    totals.subtotal = roundDown(totals.subtotal, 2);
    totals.iva = roundDown(totals.iva, 2);
    totals.amount=totals.amount.toFixed(2);

    $('input[name="ticket[subtotal]"]').val(totals.subtotal);
    $('input[name="ticket[iva]"]').val(totals.iva);
    $('input[name="ticket[amount]"]').val(totals.amount);

    applyPercent($("#tax_percent").val());

  }

  function roundDown(number, decimals) {
    console.log(number);
    if (number == 0) return number;

    decimals = decimals || 0;
    var numberString = String(number).split(".");

    if(numberString.lenght > 0) {
        console.log(numberString);

        if (+numberString[1].substr(2, 1) > 5) return number.toFixed(decimals);
    }

    return Math.floor(number * Math.pow(10, decimals)) / Math.pow(10, decimals);
  }
});
