$(function () {

    $("#tbItems tbody").html("");
    $("select").select2({ language: 'es' });
    $("#frmCustomer").parsley();

    $("#newCustomer").on("click", function () {
        document.getElementById("frmCustomer").reset();
        $("select").val('').trigger('change');
        $("#frmCustomer").data("action", "create");
        $("#titleCustomer").text("Nuevo Cliente");
        $("#modalCustomer input[name='id_contrato_cliente']").val('');
        $("#editCustomer").addClass('hidden');
        $("#infoCustomer span,#infoCustomer strong").text("");

        $("#modalCustomer").modal("show");

        return false;
    });

    $("#editCustomer").on("click", function () {

        var data = $(this).data("customer");
        $("#modalCustomer input[name='id']").val(data.id);
        $("input[name='rfc']").val(data.rfc);
        $("input[name='name']").val(data.name);
        $("input[name='email']").val(data.email);
        $("select[name='type']").val(data.type).trigger("change");
        $("#frmCustomer").data("action", "edit");
        $("#titleCustomer").text("Editar Información");
        $("#modalCustomer").modal("show");

        return false;

    });

    function setCustomerData(data) {

        $("input[name='customer_id']").val(data.id);
        $("#customerRfc").text(data.rfc);
        $("#customerName").text(data.name);
        $("#customerEmail").text(data.email == null ? 'No registrado' : data.email);
        $("#customerType").text(data.type);
        $("input[name='rfc_search']").text("");

        $("#editCustomer").data("customer", data);
        $("#editCustomer").removeClass('hidden');
    }

    $("#searchCustomer").on("click", function () {
        var rfc = $("input[name='rfc_search']").val();
        if (!rfc)
            toastr.error("Ingrese su RFC!", "Clientes", {
                closeButton: true,
                timeOut: 4000,
                progressBar: true,
                allowHtml: true
            });
        else {
            $.ajaxSimple({
                crud: 'Clientes',
                type: 'GET',
                url: $("#DATA").data("url") + '/customers/getInformation/' + rfc,
                form: "",
                loadingSelector: "#headerCustomer",
                successCallback: function (data) {

                    setCustomerData(data.customer);

                },
                errorCallback: function (data) {

                }
            });
        }

        return false;
    });

    $("#searchTicket").on("click", function () {
        var ticket = $("#ticket").val(), customer = $("#editCustomer").data('customer');
        if (!ticket) {
            toastr.error("Ingrese el nº de ticket!", "Ticket", {
                closeButton: true,
                timeOut: 4000,
                progressBar: true,
                allowHtml: true
            });

            return false;
        }

        if (!customer) {
            toastr.error("Ingrese sus datos fiscales!", "Ticket", {
                closeButton: true,
                timeOut: 4000,
                progressBar: true,
                allowHtml: true
            });

            return false;
        }

        $("#ivaTicket,#retIvaTicket").text("0.00");


        $.ajaxSimple({
            crud: 'Ticket',
            type: 'GET',
            url: $("#DATA").data("url") + '/tickets/getTicketInformation/' + ticket + '/' + customer.type,
            form: "",
            loadingSelector: "#dataTicket",
            successCallback: function (data) {
                var html = "", impuestos = 0;
                $("#dateTicket").text(data.ticket.date);
                $("#numberTicket").text("FOLIO: " + data.ticket.number_ticket);

                $("#frmInvoice input[name='ticket_id']").val(data.ticket.id);

                $.each(data.items.data.concepto, function (key, val) {

                    console.log(val);

                    html += '<tr><td>' + $.formatNumber(val.cantidad) + '</td>' +
                        '<td>' + val.descripcion + '</td>' +
                        '<td>' + val.unidad + '</td>' +
                        '<td>' + $.formatNumber(val.precio) + '</td>' +
                        '<td>' + $.formatNumber(val.importe) + '</td></tr>';
                });

                $("#tbItems tbody").html(html);
                $("#subtotalTicket").text($.formatNumber(data.items.data.factura.subtotal));
                $("#totalTicket").text($.formatNumber(data.items.data.factura.total));


                var iva = data.items.data.impuestos_federales.totalTraslados == '' ? 0 : data.items.data.impuestos_federales.totalTraslados;
                var retIva = data.items.data.impuestos_federales.totalRetenciones == '' ? 0 : data.items.data.impuestos_federales.totalRetenciones;

                $("#ivaTicket").text($.formatNumber(iva));
                $("#retIvaTicket").text($.formatNumber(retIva));

                



            },
            errorCallback: function (data) {

            }
        });


        return false;
    });

    $("#frmCustomer").on("submit", function (e) {

        var valid = $("#frmCustomer").parsley().isValid();
        var url = $("#DATA").data("url") + '/customers';

        if (valid) {
            $("input[name='_method']").val($("#frmCustomer").data("action") == 'create' ? 'PUT' : 'PATCH');
            $.ajaxFormData({
                crud: 'Clientes',
                type: 'POST',
                url: $("#frmCustomer").data("action") == 'create' ? url + '/save' : url + '/update/' + $("#frmCustomer input[name='id']").val(),
                form: "frmCustomer",
                loadingSelector: "#modalCustomer .modal-body",
                successCallback: function (data) {
                    $("#modalCustomer").modal("hide");
                    setCustomerData(data.customer);
                },
                errorCallback: function (data) {

                }

            });

        }
        return false;

    });


    $("#backTicket").on("click", function () {
        $("#modalInvoice").hide(500, function () {
            $("#infoTicket").show();
        });
        return false;
    })
    $("#invoiceSigning").on("click", function () {


        if (!$("#frmInvoice input[name='ticket_id']").val() || !$("#frmInvoice input[name='customer_id']").val()) {
            toastr.error("Ingrese sus datos y el nº de ticket!", "Tickets", {
                closeButton: true,
                timeOut: 4000,
                progressBar: true,
                allowHtml: true
            });
            return false;
        }

        $.ajaxSimple({
            crud: 'Ticket',
            type: 'POST',
            url: $("#DATA").data("url") + '/tickets/invoiceSigning',
            form: "#frmInvoice",
            loadingSelector: "#dataTicket",
            successCallback: function (data) {

                $("#pdf").attr('src', data.file);

                $("#infoTicket").hide(500, function () {
                    $("#modalInvoice").show();
                });


                $("#infoCustomer span,#infoCustomer strong").text("");
                $("#customerRfc,#dateTicket,#numberTicket,#subtotalTicket,#ivaTicket,#retIvaTicket,#totalTicket").text("");
                $("#editCustomer").addClass('hidden');
                $("#tbItems tbody").html("");
                $("#frmInvoice input[name='id']").val("");
                $("#frmInvoice input[name='customer_id']").val("");
                $("input[name='rfc_search'],#ticket").val('');

            },
            errorCallback: function (data) {

            }
        });
        return false;
    });

});