$(document).ready(function () {

    $("#newPassword").passwordStrength({targetDiv: '#passwordStrengthDivNew'});
    $("#changePassword").passwordStrength({targetDiv: '#passwordStrengthDivChange'});
    $("select").select2({language: 'es'});
    $("#formUser").parsley();


    //Users filter
    $('#dataTableBuilder').on('preXhr.dt', function (e, settings, data) {
        data.filial = $('#selectFilial').val();
        data.role = $('#selectRole').val();
    });

    $('#selectFilial,#selectRole').on('change', function () {
        $('.buttons-reload').click();
    });


    //Open modal to create a user
    $(document).on("click", "#openModalUser", function () {

        document.getElementById("formUser").reset();
        $("select").val('').trigger('change');


        $("#credentials").show()
        $("#id").val('');
        $("#formUser").data('action', 'create');
        $("#modalTitle").text('Nuevo Usuario');
        $("#modalUser").modal("show");

        return false;

    });


    //Open modal to edit a user
    $(document).on("click", "#editUser", function () {
        $("#formUser").data('action', 'edit');

        $("#formUser #email").val('');
        $("#formUser #username").val('');        
        $("#formUser #password").val('');
        $("#credentials").hide();

        $("#id").val($(this).data('id'));
        $("#modalTitle").text('Editar Usuario');

        getUserInfo($(this).data('id'), 'editData');

        return false;


    });

    //Open modal to reset user's credentials
    $(document).on("click", '#editPassword', function () {
        $("#id").val($(this).data('id'));
        getUserInfo($(this).data('id'), 'editPassword');

        return false;
    });

    //Activate user
    $(document).on('click', '#activateUser', function () {

        if (confirm('¿Está seguro(a) de activar el usuario?'))
            activateDeactive($(this).data("id"), 1);

        return false;
    });

    //Deactivate user
    $(document).on('click', '#deactivateUser', function () {
        if (confirm('¿Está seguro(a) de desactivar el usuario ?'))
            activateDeactive($(this).data("id"), 0);
        return false;
    });


    //save user data via AJAX
    $("#formUser").on("submit", function (e) {

        var valid = $("#formUser").parsley().isValid();
        if (valid) {
            saveUser();
        }
        return false;

    });


    //Save credentials via AJAX
    $("#formUserPass").on("submit", function (e) {
        var valid = $("#formUserPass").parsley().isValid();
        if (valid) {
            changePassword();
        }
        return false;
    });


    function saveUser() {

        $("input[name='_method']").val($("#formUser").data("action") == 'create' ? 'POST' : 'PATCH');


        var url = $("#DATA").data("url") + '/users';
        $.ajaxFormData({
            crud: 'Usuarios',
            type: 'POST',
            url: $("#formUser").data("action") == 'create' ? url : url + '/' + $("#id").val(),
            form: "formUser",
            loadingSelector: "#modalUser .modal-body",
            successCallback: function (data) {


                $(".buttons-reload").click();
                $("#modalUser").modal("hide");


            },
            errorCallback: function (data) {

            }

        });
    }

    //Function to get user's information
    function    getUserInfo($id, $action) {

        $.ajaxSimple({
            crud: 'Usuarios',
            type: 'GET',
            url: $("#DATA").data("url") + '/users/' + $id + '/edit',
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {

                if ($action == 'editData') {
                    $("#credentials").hide();
                    $("input[name='name']").val(data.user.name);
                    $("input[name='phone']").val(data.user.phone);
                    $("select[name='filial_id']").val(data.user.filial_id).trigger('change');
                    $("input[name='filial_id']").val(data.user.filial_id);
                    $("select[name='role_id']").val(data.user.role_id).trigger('change');
                    $("#modalUser").modal("show");
                } else {                    
                    $("input[name='username']").val(data.user.username);
                    $("#formUserPass input[name='email']").val(data.user.email);
                    $("#modalUserPass").modal("show");

                }

            },
            errorCallback: function (data) {

            }
        });


    }

    //Function to reset credentials via AJAX
    function changePassword() {

        $.ajaxFormData({
            crud: 'Cambio de Contraseña',
            type: 'POST',
            url: $("#DATA").data("url") + '/users/changePassword/' + $("#id").val(),
            form: "formUserPass",
            loadingSelector: "#modalUserPass .modal-body",
            successCallback: function (data) {


                $(".buttons-reload").click();
                $("#modalUserPass").modal("hide");


            },
            errorCallback: function (data) {

            }

        });
    }

    //Function to activate/deactive user via AJAX
    function activateDeactive(id, status) {

        $.ajaxSimple({
            crud: 'Usuarios',
            type: 'GET',
            url: $("#DATA").data("url") + '/users/setStatus/' + id + '/' + status,
            form: "",
            loadingSelector: ".panel",
            successCallback: function (data) {
                $(".buttons-reload").click();
            },
            errorCallback: function (data) {

            }
        });
    }

});