$.setLoading = function(a) {
  $(a).block({
    message: "Espere un momento...",
    centerY: true,
    css: {
      border: "none",
      padding: "15px",
      backgroundColor: "#000",
      "-webkit-border-radius": "10px",
      "-moz-border-radius": "10px",
      opacity: 0.5,
      color: "#fff"
    }
  });
};
$.ajaxFormData = function(a) {
  var b = new FormData(document.getElementById(a.form));
  $.ajax({
    type: a.type,
    url: a.url,
    contentType: false,
    processData: false,
    cache: false,
    headers: { "X-CSRF-TOKEN": $('[name="csrf_token"]').attr("content") },
    beforeSend: function() {
      $.setLoading(a.loadingSelector);
    },
    data: b,
    success: function(c) {
      $(a.loadingSelector).unblock();
      if (c.msg) {
        toastr.success(c.msg, a.crud);
      }
      a.successCallback(c);
    },
    error: function(c) {
      var d = "";
      $(a.loadingSelector).unblock();
      $.each(JSON.parse(c.responseText), function(e, f) {
        d += f + "<br/>";
      });
      toastr.error(d, a.crud, {
        closeButton: true,
        timeOut: 4000,
        progressBar: true,
        allowHtml: true
      });
      a.errorCallback(c);
    }
  });
};
$.ajaxSimple = function(a) {
  $.ajax({
    type: a.type,
    url: a.url,
    headers: { "X-CSRF-TOKEN": $('[name="csrf_token"]').attr("content") },
    beforeSend: function() {
      $.setLoading(a.loadingSelector);
    },
    data: $.param($(a.form).serializeArray()),
    success: function(b) {
      $(a.loadingSelector).unblock();
      if (b.msg) {
        toastr.success(b.msg, a.crud);
      }
      a.successCallback(b);
    },
    error: function(b) {
      var c = "";
      $(a.loadingSelector).unblock();
      $.each(JSON.parse(b.responseText), function(d, e) {
        c += e + "<br/>";
      });
      toastr.error(c, a.crud, {
        closeButton: true,
        timeOut: 4000,
        progressBar: true,
        allowHtml: true
      });
      a.errorCallback(b);
    }
  });
};
$.formatNumber = function(a) {
  return parseFloat(a)
    .toFixed(2)
    .toString()
    .replace(/\B(?=(\d{3})+(?!\d))/g, ",");
};
$.searchOnTable = function(b, c, a) {
  $("#" + b).on("keyup", function() {
    var d, f, g, h, j, e;
    d = document.getElementById(b);
    f = d.value.toUpperCase();
    g = document.getElementById(c);
    h = g.getElementsByTagName("tr");
    for (e = 0; e < h.length; e++) {
      j = h[e].getElementsByTagName("td")[a];
      if (j) {
        console.log(j.innerHTML.toUpperCase());
        if (j.innerHTML.toUpperCase().indexOf(f) > -1) {
          h[e].style.display = "";
        } else {
          h[e].style.display = "none";
        }
      }
    }
  });
};
$.ajaxDelete = function(a) {
  bootbox.dialog({
      size: 'small',
      message: '<p class="text-center"><i class="fa fa-warning fa-4x text-danger"></i></p> <div class="text-center" style="font-weight: bold;">' + a.question + '</div>',
      buttons: {
          success: {
              label: '<i class="fa fa-check"></i> Aceptar',
              className: "btn btn-sm btn-success text-white",
              callback: function () {
                  $.ajax({
                      type: 'DELETE',
                      cache: false,
                      url: $("#DATA").data("url") + a.url,
                      headers: { "X-CSRF-TOKEN": $('[name="csrf_token"]').attr("content") },
                      dataType: 'json',
                      beforeSend: function () {
                          $.setLoading(a.loadingSelector);
                      },
                      success: function (b) {
                        $(a.loadingSelector).unblock();
                        if (b.msg) {
                          toastr.success(b.msg, a.crud);
                        }
                        a.successCallback(b);
                      },
                      error: function (b) {
                        var c = "";
                        $(a.loadingSelector).unblock();
                        $.each(JSON.parse(b.responseText), function(d, e) {
                          c += e + "<br/>";
                        });
                        toastr.error(c, a.crud, {
                          closeButton: true,
                          timeOut: 4000,
                          progressBar: true,
                          allowHtml: true
                        });
                        a.errorCallback(b);
                      }
                  });
              }
          },
          main: {
              label: '<i class="fa fa-times"></i> Cancelar',
              className: "btn btn-sm btn-danger",
          }
      }
  });
};