@extends('layouts.app')
@section('styles')
    {{ Html::style('https://cdn.datatables.net/buttons/1.0.3/css/buttons.dataTables.min.css') }}
    {{ Html::style('assets/global/plugins/bootstrap-select/css/bootstrap-select.min.css') }}
@endsection
@section('content')
    <div class="portlet light bordered">
        <div class="portlet-title">
            <div class="caption">
                <i class="fa fa-list font-red-sunglo"></i>
                <span class="caption-subject font-red-sunglo bold uppercase">Cancelaciones respondidas: {{session('empresaName')}}</span>
            </div>
        </div>
        <div class="clearfix"></div>
        @include('facturas.extras.modalcorreo')
        @include('layouts.common.loaderajax')
        @include('flash::message')
        <div class="portlet-body">
            <div class="row">
                {!! $dataTable->table(['width' => '100%']) !!}
            </div>
        </div>
    </div>
@endsection

@section('pluginScripts')
    {{ Html::script('assets/global/plugins/bootstrap-select/js/bootstrap-select.min.js') }}
@endsection
@section('pageScripts')
    {{ Html::script('assets/pages/scripts/components-bootstrap-select.min.js') }}
    {{ Html::script('assets/global/scripts/datatable.js') }}
    {{ Html::script('assets/global/plugins/datatables/datatables.min.js') }}
    {{ Html::script('assets/global/plugins/datatables/plugins/bootstrap/datatables.bootstrap.js') }}
    {{ Html::script('assets/global/plugins/datatables/buttons.server-side.js') }}
    {!! Html::script('js/common.js') !!}
    {!! Html::script('js/facturas/datatableIndex.js') !!}
    {!! $dataTable->scripts() !!}
@endsection