@extends('layouts.app')
@section('styles')
    {{ Html::style('https://cdn.datatables.net/buttons/1.0.3/css/buttons.dataTables.min.css') }}
    {{ Html::style('js/plugins/jQuery-Ambiance/jquery.ambiance.css') }}
@endsection
@section('content')
    <div class="portlet light bordered">
        <div class="portlet-title">
            <div class="caption">
                <i class="fa fa-ban font-red-sunglo"></i>
                <span class="caption-subject font-red-sunglo bold uppercase">Peticiones de cancelaciones de facturas: {{session('empresaName')}}</span>
            </div>
        </div>
        <div class="clearfix"></div>
        {{--@include('facturas.extras.modalcorreo')
        @include('layouts.common.loaderajax')--}}
        @include('flash::message')
        <div class="portlet-body">
            @if(isset($response['message']))
                <div class="alert alert-success">
                    <strong>{{ $response['codStatus'] }}</strong>
                    {{ $response['message'] }}
                </div>
            @else
                <div class="alert alert-danger">
                    <strong>¡Error!</strong>
                    Error al consultar las facturas con solicitudes de cancelación
                </div>
            @endif
            <table class="table" id="dataTableBuilder">
                <thead>
                    <tr>
                        <th>UUID</th>
                        <th>Acción</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach($response['data']['uuid'] as $uuid)
                        <tr>
                            <td>{{ $uuid }}</td>
                            <td>
                                <a href="javascript:;" class="btn btn-success change" data-route="{{ route('cancelaciones.update', ['aceptar', $uuid]) }}" data-action="aceptar"><i class="fa fa-thumbs-up"></i>Aceptar</a>
                                <a href="javascript:;" class="btn btn-danger change" data-route="{{ route('cancelaciones.update', ['rechazar', $uuid]) }}" data-action="rechazar"><i class="fa fa-thumbs-down"></i>Rechazar</a>
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
        </div>
    </div>
@endsection
@section('pageScripts')
    {{ Html::script('assets/global/scripts/datatable.js') }}
    {{ Html::script('assets/global/plugins/datatables/datatables.min.js') }}
    {{ Html::script('assets/global/plugins/datatables/plugins/bootstrap/datatables.bootstrap.js') }}
    {{ Html::script('assets/global/plugins/datatables/buttons.server-side.js') }}
    {{ Html::script('assets/global/plugins/bootbox/bootbox.min.js') }}
    {{ Html::script('js/plugins/jQuery-Ambiance/jquery.ambiance.js') }}
    {!! Html::script('js/common.js') !!}
    {!! Html::script('js/facturas/cancelaciones/index.js') !!}
@endsection