@extends('layouts.app')

@section('content')

@include('tickets.modalGlobalPdf')
@include('tickets.invoice.layouts.modalCustomer')

{{Form::open(['id'=>'frmGlobal','autocomplete'=>'off'])}}
    <div class="panel panel-inverse">
        <div class="panel-heading">
            <h4 class="panel-title">Timbrar Factura Global</h4>
        </div>

        <div class="panel-toolbar">

            <div class="row text-center">
                <div class="hidden col-lg-3">
                    <label for="" class="control-label">Base</label>
                    {{Form::select('filial',App\Models\Filial::activated()->get()->pluck('name','id'),6,
                        ['class'=>'form-control',
                            'id'=>'filial',
                            'placeholder'=>"Seleccione base"])}}
                </div>
                <div class="col-lg-3">
                    <label for="" class="control-label">Aerolinea</label>
                    {{Form::select('method_payment',App\Models\MethodPayment::where("type","=","aerolinea")->get()->pluck('description','id'),null,
                        ['class'=>'form-control',
                            'id'=>'method_payment',
                            'placeholder'=>"Tickets ajenos a aerolineas"])}}
                </div>
                <div class="col-lg-6">
                        <label for="" class="control-label">Rango de fechas</label>
                        <div class="input-group input-daterange">
                            <input type="text" class="form-control" id="from" >
                            <div class="input-group-addon">a</div>
                            <input type="text" class="form-control" id="to">
                        </div>
                </div>
                
                    
                <div class="col-lg-2">
                    <button type="button" class="btn btn-primary btn-md m-t-20" id="searchTickets">
                        <i class="fa fa-search"></i> Buscar tickets
                    </button>
                </div>
            </div>
            
        </div>
        <div class="panel-body">

            <div class="col-lg-2">

                <div class="form-horizontal">
                    <label for="tax" class="control-label">IVA</label>
                    {{Form::select('tax',["0"=>"IVA 0%",".16"=>"IVA 16%"],null,
                        ['class'=>'form-control',
                            'id'=>'tax_percent'])}}
                </div>

                <div class="row m-t-10 text-center">
                    <button name="checkTickets" data-cantidad="10" type="button" class="btn btn-info"><i class="fa fa-ticket"></i> +10</button>
                </div>
                <div class="row m-t-10 text-center">
                    <button name="checkTickets" data-cantidad="20" type="button" class="btn btn-info"><i class="fa fa-ticket"></i> +20</button>
                </div>
                <div class="row m-t-10 text-center">
                    <button name="checkTickets" data-cantidad="50" type="button" class="btn btn-info"><i class="fa fa-ticket"></i> +50</button>
                </div>
                <div class="row m-t-10 text-center">
                    <button name="checkTickets" data-cantidad="100" type="button" class="btn btn-info"><i class="fa fa-ticket"></i> +100</button>
                </div>
            </div>
            <div class="col-lg-10">
                <div class="row m-t-10 text-center">
                    <div class=" table-responsive col-lg-12">
                        <table class="table table-bordered table-rounded" id="tbTickets">
                            <thead>
                                <tr>
                                    <th class="col-lg-1">

                                        <label class="container">
                                            <input type="checkbox" id="addAll" />
                                            <span class="checkmark"></span>
                                        </label>
                                        s
                                    </th>
                                    <th class="col-lg-2">Folio</th>
                                    <th class="col-lg-2">Fecha</th>
                                    <th class="col-lg-2">Subtotal</th>
                                    <th class="col-lg-2">IVA</th>
                                    <th class="col-lg-2">Total</th>
                                </tr>
                            </thead>
                            <tbody>

                            </tbody>

                            <tfoot>
                                <thead>
                                    <tr>
                                        <th class="col-lg-5">Totales</th>
                                        <th class="col-lg-2">
                                            <span class="badge badge-success m-b-10" id="globalSubtotal"></span>
                                             <input type="text" readonly class="form-control" name="ticket[subtotal]" data-parsley-required="true">
                                        </th>
                                        <th class="col-lg-2" >
                                            <span class="badge badge-success m-b-10" id="globalIva"></span>
                                            <input type="text" readonly class="form-control" name="ticket[iva]" data-parsley-required="true">
                                        </th>
                                        <th class="col-lg-2">
                                            <input type="text" readonly class="form-control" name="ticket[amount]" data-parsley-required="true"  data-parsley-total>
                                        </th>
                                    </tr>
                                </thead>
                            </tfoot>
                        </table>
                    </div>
                </div>
            </div>

           
            
            

            <div class="row">
                @include("tickets.invoice.clientInvoice")

                <div class="col-lg-12 text-center">
                    <button class="btn btn-danger btn-lg" type="submit">
                        <i class="fa fa-file-pdf-o"> Timbrar</i>
                    </button>
                </div>
            </div>
            
        </div>

    </div>
{{Form::close()}}




@endsection



@section('plugins_css')
    {{Html::style('css/custom-checkbox.css')}}
    {{Html::style('css/ticket-globalInvoice.css')}}
    {{Html::style('vendor/material/plugins/bootstrap-datepicker/css/bootstrap-datepicker.min.css')}}
    {{Html::style('vendor/material/plugins/touchspin/src/jquery.bootstrap-touchspin.css')}}
    {{Html::style('vendor/material/plugins/switchery/switchery.min.css')}}

@endsection


@section('js_customs')

    {{Html::script('vendor/material/plugins/pdfObject/pdfobject.min.js')}}
    {{Html::script('vendor/material/plugins/bootstrap-datepicker/js/bootstrap-datepicker.min.js')}}
    {{Html::script('vendor/material/plugins/bootstrap-datepicker/js/locales/bootstrap-datepicker.es.min.js') }}
    {{Html::script('vendor/material/plugins/touchspin/src/jquery.bootstrap-touchspin.js') }}
    {{Html::script('vendor/material/plugins/switchery/switchery.min.js')}}

    <!-- Archivo de produccion -->
    {{Html::script(mix('js/production/globalInvoice.js'))}}
    {{Html::script(mix('js/production/customerInfo.js'))}}

@endsection