@extends('layouts.app')

@section('content')

    @include('flash::message')
    @include('tickets.modalEmail')
    @include('tickets.modalBond')
    @include('tickets.modalNote')
    @include('tickets.modalGlobalBond')

    <div class="modal" tabindex="-1" role="dialog" id="modalTicket">
        <div class="modal-dialog" role="document" style="width:330px!important;">
            <div class="modal-content">
                <div class="modal-header bg-black">
                    <button type="button" class="close text-white" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <h4 class="modal-title text-white">Ticket</h4>
                </div>
                <div class="modal-body">
                    <div class="row">
                        <div class="col-lg-12">
                            <div id="contentFrame"></div>
                            <iframe id="frameTicket" name="frameTicket" src=""  frameborder="0" width="auto" height="600" style="display:none!important;"></iframe>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <a id="re-print" class="btn btn-inverse btn-icon btn-circle btn-lg"><i class="fa fa-print"></i></a>
                    <button type="button" class="btn btn-primary" data-dismiss="modal">Aceptar</button>
                </div>
            </div>
        </div>
    </div>
      
    <div class="row ui-sortable" id="allPanel">
        <!--<div class="note note-warning">
            <h4> Nota del cambio V2.0.0 </h4>
            <p>
                Por tema de seguridad, en esta nueva versión (v2.0.0) se ha generado un folio de ticket aleatorio.
                También se habilita la nueva facturación, para tickets del aeropuerto,
                en el menú de "Timbrado Factura Global".
            </p>
        </div>-->
        <div class="panel panel-inverse">
            <div class="panel-heading">
                <h4 class="panel-title">Historial de Ventas</h4>

            </div>

            @if (Auth::user()->role->permissions()->first()->general_report)
            <!-- begin row -->
            <div class="row">
                <!-- begin col-3 -->
                <div class="col-md-3 col-sm-6">
                    <div class="widget widget-stats bg-green">
                        <div class="stats-icon"><i class="fa fa-money"></i></div>
                        <div class="stats-info">
                            <h4>Monto Total <span id="dashboard_noTicket"></span> Tickets: </h4>
                            <p id="dashboard_amountTotal"></p>
                        </div>
                        <div class="stats-info">
                            <h4>Monto Prueba <span id="dashboard_noTicketInvalid"></span> Tickets: </h4>
                            <p id="dashboard_amountNoValid"></p>
                        </div>
                        <div class="stats-link">
                            <a href="javascript:;">View Detail <i class="fa fa-arrow-circle-o-right"></i></a>
                        </div>

                    </div>
                </div>
                <!-- end col-3 -->
                <!-- begin col-3 -->
                <div class="col-md-3 col-sm-6">
                    <div class="widget widget-stats bg-green">
                        <div class="stats-icon"><i class="fa fa-sort-numeric-asc"></i></div>
                        <div class="stats-info">
                            <h4>Monto en Efectivo</h4>
                            <div id="dashboard_amountMoney">

                            </div>
                        </div>
                        <div class="stats-link">
                            <a href="javascript:;">View Detail <i class="fa fa-arrow-circle-o-right"></i></a>
                        </div>
                    </div>
                </div>
                <!-- end col-3 -->
                <!-- begin col-3 -->
                <div class="col-md-3 col-sm-6">
                    <div class="widget widget-stats bg-green">
                        <div class="stats-icon"><i class="fa fa-file-code-o"></i></div>
                        <div class="stats-info">
                            <h4>Monto Facturado</h4>
                            <p id="dashboard_amountInvoice"></p>
                        </div>
                        <div class="stats-info">
                            <h4>Monto en Faturas canceladas</h4>
                            <p id="dashboard_amountInvoiceCancelled"></p>
                        </div>
                        <div class="stats-link">
                            <a href="javascript:;">View Detail <i class="fa fa-arrow-circle-o-right"></i></a>
                        </div>
                    </div>
                </div>
                <!-- end col-3 -->
                <!-- begin col-3 -->
                <div class="col-md-3 col-sm-6">
                    <div class="widget widget-stats bg-green">
                        <div class="stats-icon"><i class="fa fa-exchange"></i></div>
                        <div class="stats-info">
                            <h4>Monto Pagados</h4>
                            <p id="dashboard_amountPay"></p>
                        </div>
                        <div class="stats-link">
                            <a href="javascript:;">View Detail <i class="fa fa-arrow-circle-o-right"></i></a>
                        </div>
                    </div>
                </div>
                <!-- end col-3 -->
            </div>
            <!-- end row -->
        
            <div class="panel-toolbar">
                <form id="formFilter">
                <div class="row">
                        {{--  <div class="col-lg-3">
                            {{Form::label('customer','Cliente')}}
                            {{Form::select(null,$customers,null,["class"=>"form-control select2","placeholder"=>"Ver Todos","style"=>"width:100%","id"=>"selectCustomer"])}}
                        </div>
                        <div class="col-lg-2">
                            {{Form::label('cliente','Status')}}
                            {{Form::select(null,["sell"=>"Ticket","global_sell"=>"Ticket en global","cancelled"=>"Ticket cancelado","invoiced"=>"Factura","invoice_cancelled"=>"Factura Cancelada","invoice_sell"=>"Factura Global",],null,["class"=>"select2 form-control","style"=>"width:100%","id"=>"selectStatus","multiple"])}}
                        </div>  --}}

                        {{--  @if(Auth::user()->role->permissions->general_report)
                            <div class="col-lg-2">
                                {{Form::label('cliente','Sucursal')}}
                                {{Form::select(null,$filials,null,["class"=>"select2 form-control","placeholder"=>"Ver Todos","style"=>"width:100%","id"=>"selectFilial"])}}
                            </div>
                        @endif  --}}

                        {{--  @if(Auth::user()->role->permissions->general_report)
                            <div class="col-lg-2">
                                {{Form::label('cliente','Usuario')}}
                                {{Form::select(null,[],null,["class"=>"select2 form-control","placeholder"=>"Ver Todos","style"=>"width:100%","id"=>"selectUser"])}}
                            </div>
                        @endif  --}}


                        <div class="col-lg-6">
                            <label for="vendedor">Rango de Fechas: </label>
                            <div class="input-group input text-center" data-date="10/11/2012"
                                id="defaultrange"
                                data-date-format="mm/dd/yyyy">
                                <input type="text" class="form-control" id="txtFrom" name="txtFrom">
                                <span class="input-group-addon"> a </span>
                                <input type="text" class="form-control" id="txtTo" name="txtTo"></div>
                            <!-- /input-group -->
                        </div>

                        <div class="form-group col-lg-3">
                            <label for="owners">Dueños </label>
                            {!! Form::select("owners",$owners,null,["placeholder"=>"Selecciona el Dueño","class"=>"select2 form-control","id"=>"selectOwner"]) !!}
                            <!-- /input-group -->
                        </div>

                        <div class="form-group col-lg-3">
                            {{Form::label("status",'Estatus de Ticket', ["class" => "m-r-10"])}}
                            {!! Form::select("status[]",array("sell" => "Venta",
                                                            "invoiced"=> "Factura",
                                                            "invoice_sell" => "Factura Global",
                                                            "invoice_cancelled" => "Factura Cancelada",
                                                            "cancelled" => "Ticket Cancelado",
                                                            "global_sell" => "Ticket en Factura Global",
                                                            "system_no_valid" => "No validos"
                                                            ),null,["class"=>"select2 form-control","multiple"=>"multiple","id"=>"selectStatus"]) !!}
                            <!-- /input-group -->
                        </div>
                        <div class="form-group col-lg-3">
                            {{Form::label(null,'En Efectivo', ["class" => "m-r-10"])}}
                            <input id="withMoney" name="withMoney" type="checkbox" data-render="switchery" value="0" class="m-l-10"/>
                            <!-- /input-group -->
                        </div>
                        <div class="form-group col-lg-3">
                            {{Form::label(null,'Facturados', ["class" => "m-r-10"])}}
                            <input id="withInvoice" name="withInvoice" type="checkbox" data-render="switchery" value="0" class="m-l-10"/>
                            <!-- /input-group -->
                        </div>
                        <div class="form-group col-lg-3">
                            {{Form::label(null,'Pagados', ["class" => "m-r-10"])}}
                            <input id="withPayed" name="withPayed" type="checkbox" data-render="switchery" value="0" class="m-l-10"/>
                            <!-- /input-group -->
                        </div>
                        <div class="form-group col-lg-3">
                            {{Form::label(null,'Pruebas (No validos)', ["class" => "m-r-10"])}}
                            <input id="noValid" name="noValid" type="checkbox" data-render="switchery" value="0" class="m-l-10"/>
                            <!-- /input-group -->
                        </div>

                    <div id="divMoreFilters" class="form-group col-lg-12 hidden">
                        <div class="form-group col-lg-3">
                            <label for="method_payments">Metodos de Pago </label>
                            {!! Form::select("method_payments",$method_payments,null,["multiple"=>"multiple","class"=>"select2 form-control","id"=>"selectMethodPayment"]) !!}
                        </div>
                        <div class="form-group col-lg-3">
                            <label for="coins">Moneda </label>
                            {!! Form::select("coins",$coins,null,["placeholder"=>"Selecciona una Moneda","class"=>"select2 form-control","id"=>"selectCoin"]) !!}
                        </div>
                    </div>
                        <div class="form-group col-lg-3">
                            <button type="button" name="generateReport"
                                    id="generateReport"
                                    data-route="{{ route('tickets.report') }}"
                                    class='btn btn-info btn-sm'>
                                <i class="glyphicon glyphicon-stats"></i> Generar Reporte
                            </button>
                        </div>
                    </div>
                </form>
                </div>
            @endif
            <div class="panel-body loadingTickets">
                 {{--@if(\Auth::user()->role->permissions->mark_bond)
                    <div class="row m-b-15">
                        <div class="col-lg-12 text-right">
                            <button class="btn btn-default" id="markBank">
                            <i class="fa fa-bank text-warning"></i>    Marcar Depósito para seleccionadas
                            </button>
                        </div>
                    </div>
                @endif--}}
                @include('tickets.table')
            </div>
    </div>


@endsection
