<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();
Route::get('/logout', 'Auth\LoginController@logout');
Route::get('/home', 'HomeController@index');

//Customer
Route::put('customers/save', 'CustomerController@save')->name('customers.save');
Route::get('customers/getInformation/{rfc}', 'CustomerController@getInformation')->name('customers.getInformation');
Route::patch("customers/update/{customer_id}", "CustomerController@update");

//Ticket invoicing
Route::get('tickets/invoice', 'TicketController@invoice')->name('tickets.invoice');
Route::post('tickets/invoiceSigning', 'TicketController@invoiceSigning')->name('tickets.invoiceSigning');
Route::get('tickets/getTicketInformation/{number_ticket}/{customer_type}', 'TicketController@getTicketInformation')->name('tickets.getTicket');
Route::get('tickets/invoiceHistory', 'TicketController@invoiceHistory')->name('tickets.invoiceHistory');
// Route::get('tickets/print/{id}', 'TicketController@printPaper')->name('tickets.printPaper');


Route::group(['middleware' => ['auth']], function () {

    Route::get('cancelacion/historial', 'CancelacionController@historial');
    Route::get('cancelacion', 'CancelacionController@index')->name('cancelacion.index');

    Route::get('customers/setStatus/{id}/{status}/', 'CustomerController@setStatus');
    Route::get('customers', 'CustomerController@index')->name('customers.index');

    /*Global ticket items */
    Route::get('ticketGlobalItems/getItems/{id}', 'TicketGlobalItemController@getItems')->name('ticketGlobalItems.getItems');
    Route::post('ticketGlobalItems/updateBondDates', 'TicketGlobalItemController@updateBondDates')->name('ticketGlobalItems.updateBondDates');

    Route::get('tickets/reInvoice/{id}', 'TicketController@reInvoice')->name('ticket.reInvoice');
    Route::get('tickets/ticketRemakeAll', 'TicketController@ticketRemakeAll')->name('ticket.ticketRemakeAll');
    Route::get('tickets/ticketXMLRemake/{id}', 'TicketController@ticketXMLRemake')->name('ticket.ticketXMLRemake');
    Route::post('tickets/getSearchTicket', 'TicketController@getSearchTicket')->name('ticket.getSearchTicket');
    Route::post('tickets/getTotals', 'TicketController@getTotals')->name('ticket.getTotals');
    Route::post('tickets/setBond', 'TicketController@setBond')->name('tickets.setBond');
    Route::post('tickets/editNote', 'TicketController@editNote')->name('tickets.editNote');
    Route::post('tickets/sendInvoice', 'TicketController@sendInvoice')->name('tickets.sendInvoice');
    Route::get('tickets/cancelInvoice/{id}', 'TicketController@cancelInvoice')->name('tickets.cancelInvoice');
    Route::post('tickets/requestCancelTicket', 'TicketController@requestCancelTicket')->name('tickets.requestCancelTicket');
    Route::get('tickets/cancelTicket/{id}', 'TicketController@cancelTicket')->name('tickets.cancelTicket');
    Route::get('tickets/invalidTicket/{id}', 'TicketController@invalidTicket')->name('tickets.invalidTicket');
    Route::get('tickets/index', 'TicketController@index')->name('tickets.index');
    Route::get('tickets/sell', 'TicketController@sell')->name('tickets.sell');
    Route::get('tickets/printexample', 'TicketController@printExample')->name('tickets.printExample');
    Route::get('tickets/print/{id}', 'TicketController@printPaper')->name('tickets.printPaper');
    Route::get('tickets/print2/{id}', 'TicketController@printPaper2');
    Route::post('tickets/store', 'TicketController@store')->name('tickets.store');
    Route::post('tickets/report', 'TicketController@report')->name('tickets.report');

    //Global invoice
    Route::get('tickets/globalInvoice', 'TicketController@globalInvoice')->name('tickets.globalInvoice');
    Route::get('tickets/getGlobalTickets/{filial}/{from}/{to}/{methodPayment?}', 'TicketController@getGlobalTickets')->name('tickets.getGlobalTickets');
    Route::post('tickets/signGlobalInvoice', 'TicketController@signGlobalInvoice')->name('tickets.signGlobalInvoice');

    Route::get('filials/setStatus/{id}/{status}/', 'FilialController@setStatus');
    Route::get('filials/getUsers/{id}', 'FilialController@getUsers');
    Route::resource('filials', 'FilialController');

    Route::get('items/setStatus/{id}/{status}/', 'ItemController@setStatus');
    Route::resource('items', 'ItemController');

    Route::get('roles/setStatus/{id}/{status}/', 'RoleController@setStatus');
    Route::resource('roles', 'RoleController');

    Route::get('taxConfigs/setStatus/{id}/{status}/', 'TaxConfigController@setStatus');
    Route::resource('taxConfigs', 'TaxConfigController');

    Route::get('taxItemsConfig/deleteTax/{tax_config_id}/{tax_id}', 'TaxConfigItemController@delete');

    Route::patch('users/changePassword/{id}/', 'UserController@changePassword');
    Route::get('users/setStatus/{id}/{status}/', 'UserController@setStatus');
    Route::resource('users', 'UserController');

    Route::get('measureUnits/setStatus/{id}/{status}/', 'MeasureUnitController@setStatus');
    Route::resource('measureUnits', 'MeasureUnitController');

    Route::post('rates/getRates', 'RateController@getRates');
    Route::post('rates/importRates', 'RateController@updloadNewRates')->name("rates.import");
    Route::resource('rates', 'RateController');

    Route::resource('cars', 'CarController');

    Route::post('owners/getPayTicket', 'OwnerController@getPayTicket')->name('owners.getPayTicket');
    Route::resource('owners', 'OwnerController');

    Route::get('coins/changeStatus/{id}/{status}', 'CoinController@changeStatus');
    Route::resource('coins', 'CoinController');

    Route::post('methodPayments/getPayMethod', 'MethodPaymentController@getPayMethod');
    Route::get('methodPayments/changeStatus/{id}/{status}', 'MethodPaymentController@changeStatus');
    Route::resource('methodPayments', 'MethodPaymentController');

    Route::get('exchangeRates/getCurrent', 'ExchangeRateController@getcurrent');
    Route::resource('exchangeRates', 'ExchangeRateController');

    Route::get('userShifts/viewClose/{id}', 'UserShiftController@viewClose')->name("userShifts.viewClose");
    Route::get('userShifts/open/{id}', 'UserShiftController@open')->name("userShifts.open");
    Route::get('userShifts/getClose', 'UserShiftController@getClose')->name("userShifts.getClose");
    Route::get('userShifts/getCRCumulative/{cash_register_id}', 'UserShiftController@getCRCumulative')->name("userShifts.getCRCumulative");
    Route::get('userShifts/getCRDisponible', 'UserShiftController@getCRDisponible')->name("userShifts.getCRDisponible");
    Route::get('userShifts/checkShift', 'UserShiftController@checkShift')->name("userShifts.checkShift");
    Route::resource('userShifts', 'UserShiftController');
    Route::resource('cashOutbounds', 'CashOutboundController');
    Route::post('ticketPays/{id_ticket}', 'TicketPayController@storeTicketPay')->name("ticketPays.storeTicketPay");
    Route::resource('ticketPays', 'TicketPayController');

    Route::post('cashRegisters/changeStatus', 'CashRegisterController@changeStatus')->name("cashRgisters.changeStatus");
    Route::resource('cashRegisters', 'CashRegisterController');

    Route::resource('cashbacks', 'CashbackController');

});


//User Owner panel
Route::group(["namespace"=>'AuthOwner'],function (){
    Route::get('user_owner/login','LoginController@showLoginForm')->name('user_owners.showLoginForm');
    Route::post('user_owner/login','LoginController@login')->name('user_owners.login');
});


Route::group(['middleware' => ['owner']], function(){
    Route::get('user_owner/profile','OwnerController@profile')->name('user_owners.profile');
    Route::get('user_owner/historyTickets','OwnerController@historyTickets')->name('user_owners.historyTickets');
    Route::get('user_owner/dashboard','OwnerController@historyTickets')->name('user_owners.historyTickets');
    Route::get('user_owner/dashboard','OwnerController@historyTickets')->name('user_owners.dashboard');

});

