let mix = require('laravel-mix');

/*
 |--------------------------------------------------------------------------
 | Mix Asset Management
 |--------------------------------------------------------------------------
 |
 | Mix provides a clean, fluent API for defining some Webpack build steps
 | for your Laravel application. By default, we are compiling the Sass
 | file for the application as well as bundling up all the JS files.
 |
 */

mix.js('resources/assets/js/app.js', 'public/js')
  .sass('resources/assets/sass/app.scss', 'public/css');


// Filials module
mix.js('public/js/filials/app.js', 'public/js/production/filials.js')
  .version();

//customers module
mix.js('public/js/customers/app.js', 'public/js/production/customers.js')
.version();

//Unit measures module
mix.js('public/js/measureUnits/app.js', 'public/js/production/measureUnits.js')
.version();

//Roles module
mix.js('public/js/roles/app.js', 'public/js/production/roles.js')
  .version();

//Users module
mix.js('public/js/users/app.js', 'public/js/production/users.js')
  .version();

//Tax Configs module
mix.scripts(['public/js/taxConfigs/app.js', 'public/js/taxConfigs/taxes.js'], 'public/js/production/taxConfigs.js')
  .version();

//Items module
mix.js('public/js/items/app.js', 'public/js/production/items.js')
  .version();

// Tickets module
mix.js('public/js/tickets/app.js', 'public/js/production/sellTickets.js')
  .version();

  mix.js('public/js/tickets/invoiceTicket.js', 'public/js/production/invoiceTicket.js')
  .version();

  mix.js('public/js/tickets/ticketHistory.js', 'public/js/production/ticketHistory.js')
  .version();

  mix.js('public/js/tickets/globalInvoice.js', 'public/js/production/globalInvoice.js')
  .version();

  mix.js('public/js/tickets/customerInfo.js', 'public/js/production/customerInfo.js')
    .version();


  mix.js('public/js/tickets/clientHistoryTickets.js', 'public/js/production/clientHistoryTickets.js')
  .version();
